{bot}
{auth is an authentication service primerally intended for use with quakenets}
{lightweight this can be obtained from cvs.quakenet.org}
{auths default nick is A}

(*
 *  beware IRC services, authbot.pas
 *  Copyright (C) 2002 Bas Steendijk
 *
 *  modifications by peter green
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *)

unit authbot;

interface

uses
  accountcore      , buser        , bconsts    , pgmail          ,
  sysutils         , pgdebugout   , bircrandom , pgtypes         ,
  accountUSINGbot  , bservicemngr , bstuff     , authbot_replies ,
  generalreplies   ;

//const


type
  tauthbot=class(taccountUSINGbot)
  public
    locopt:record

      securelogin:boolean;
      maxlogins:integer;

      nickserv:boolean;
      emailreg   : boolean;
      mailserver : string;
      fromemail:string;
      fromemailrealname:string;
      mailthrottle:integer;
      registerthrottle:integer;
      accountlifetime:integer;
    end;
    authmailfile:string;
    requestpassmailfile:string;

    //  function validcomname(s:string):boolean;

    //procedure deauth(us:tuser);

    procedure botinit;override;

    procedure setupsrvunit;override;
    procedure buildoptiontable;override;
    procedure localtimehandler;override;
    procedure botsave(saveall:boolean);override;
    //procedure botinit;override;
    constructor create;
    function localloginchecks(sptr:tuser;parc:integer;parv:pparams;const msg:string) : boolean ;override;
    procedure sendversionreply;override;
    procedure expireaccounts;
  end;
  trequestmailsession = class
    account : string;
    client  : string;
    bot     : tauthbot;
    procedure mailfinished(reply : string);
  end;
  tnewpassmailsession = class
    account : string;
    client  : string;
    bot     : tauthbot;
    procedure mailfinished(reply : string);
  end;



{==============================================================================}

//procedure onsendburst(tag:taddrint);
//procedure ondisconnect(tag:taddrint);
//procedure onstartup(tag:taddrint);
//procedure authbotshutdown(tag:taddrint);
//procedure ontimer(tag:taddrint);
//procedure onaccount(sptr:tuser;us:tuser;tag:taddrint);

//procedure onrehash(tag:taddrint);


implementation

uses
  bconfig     , bparse       , bcmds        ,
  bchannel    , btime        , passcryp     , blinklist    , bcrash         ,
  bservunit   , unitbanmask  , readtxt      , boptiontable , authipthrottle ,
  bsetcommand , authemailban , unitwritetxt , authcommands , pgstuff        ;


procedure trequestmailsession.mailfinished(reply : string);
var
  p : taccount;
  us:tuser;
begin
 with bot do begin
  //sendtalk := sendtalkstr(mybot,sptr);
  debugout('tmailrequestsession.mailfinished entered');
  us := findnumeric(client);
  sendtalk := sendprefixstr(mybot)+TOK_NOTICE+' '+client+' :';
  if reply[1] = '2' then begin
    if us <> nil then send(sendtalk+reply_createmailsuccess);

  end else begin

    //if us <> nil then send(sendtalk+'sending email failed, account '+account+' deleted');
    if us <> nil then send(sendtalk+replacealias(reply_mailfailedaccountdeleted,'%account%',account ));

    logaction(us,log_emailfailed+' '+reply);

    p := taccountUSINGserviceunit(srvunit).accountcore.findaccount(account);
    if p <> nil then begin
      linklistdel(tlinklist(taccountUSINGserviceunit(srvunit).accountcore.accountlist),tlinklist(p));
      p.destroy;
    end;
  end;
  sendflush;

 end;
 free;
end;
procedure tnewpassmailsession.mailfinished(reply : string);
var
  p : taccount;
  us:tuser;
begin
 with bot do begin
  //sendtalk := sendtalkstr(mybot,sptr);
  debugout('tmailrequestsession.mailfinished entered');

  us := findnumeric(client);

  sendtalk := sendprefixstr(mybot)+TOK_NOTICE+' '+client+' :';
  if reply[1] = '2' then begin
    if us <> nil then send(sendtalk+reply_passwordmailedok);
  end else begin
    if us <> nil then send(sendtalk+reply_sendingemailfailed);
    logaction(us,log_emailfailed+' '+reply);
    p := taccountUSINGserviceunit(srvunit).accountcore.findaccount(account);
    if p <> nil then begin
{      p.password := oldpass;}
    end;

  end;
  sendflush;

 end;
 free;
end;

procedure tauthbot.setupsrvunit;
begin
  inherited setupsrvunit;
  //srvunit := createserviceunit;
  srvunit.name := 'auth';


end;


procedure tauthbot.buildoptiontable;
var
  startat : integer;
begin


  startat := maxoptiontable+1;
  inc(maxoptiontable,10);

  inherited buildoptiontable;
  with optiontable[startat] do begin
    p:=@locopt.securelogin;
    typ:=opt_bool;
    name:='securelogin';
    info:='require "/msg nick@server login"';
    def_b:=true;
  end;
  with optiontable[startat+1] do begin
    p:=@locopt.maxlogins;
    typ:=opt_int;
    name:='maxlogins';
    info:='maximum number users who can be logged in to one account';
    def_i:=2;
  end;
  with optiontable[startat+2] do begin
    p:=@locopt.mailthrottle;
    typ:=opt_int;
    name:='MailThrottle';
    info:='minimum time in seconds between 2 password mails to one account';
    def_i:=3600;
  end;
  with optiontable[startat+3] do begin
    p:=@locopt.registerthrottle;
    typ:=opt_int;
    name:='RegisterThrottle';
    info:='minimum time in seconds between 2 account registration attempts from one IP';
    def_i:=86400;
  end;
  with optiontable[startat+4] do begin
    p:=@locopt.nickserv;
    typ:=opt_bool;
    name:='NickServ';
    info:='Enable NickServ functionality.';
    def_b:=false;
  end;
  with optiontable[startat+5] do begin
    p:=@locopt.emailreg;
    typ:=opt_bool;
    name:='emailreg';
    info:='use email for registration';
    def_b:=false;
  end;
  with optiontable[startat+6] do begin
    p:=@locopt.mailserver;
    typ:=opt_str;
    name:='mailserver';
    info:='SMTP server to use for sending account registration mails';
    def_s:='127.0.0.1';
  end;
  with optiontable[startat+7] do begin
    p:=@locopt.fromemail;
    typ:=opt_str;
    name:='fromemail';
    info:='source email address which appears in emails sent by auth service';
    def_s:='authservice@localhost';
  end;
  with optiontable[startat+8] do begin
    p:=@locopt.fromemailrealname;
    typ:=opt_str;
    name:='fromemailrealname';
    info:='"real name" for source email address';
    def_s:='Auth service';
  end;
  with optiontable[startat+9] do begin
    p:=@locopt.accountlifetime;
    typ:=opt_int;
    name:='AccountLifetime';
    info:='account expires if noone has logged in to it for this long, in seconds';
    def_i:=40*86400;
  end;

end;

procedure tauthbot.botinit;
begin
  inherited botinit;

  //accountcore.loadaccount(accountsfile);
  loademailban(emailbanfile);
end;

procedure tauthbot.localtimehandler;
begin
  authipthrottle.timehandler(self);
  expireaccounts;
end;

procedure tauthbot.botsave;
begin
  inherited botsave(saveall);
  saveemailban(emailbanfile);
end;

constructor tauthbot.create;
begin
  inherited create;
  cmdtab := @authcommands.cmdtab;
  botmaxcmd := authcommands.botmaxcmd;
  buildsorted;
  commandsfile:='auth.com.ini';
  configfile:='auth.ini';
  cfgtag:='[Auth]';
  //accountsfile='auth.accounts.ini';
  emailbanfile:='auth.emailban.ini';

  botlogfile:='auth.log';
  authmailfile:='authmail.txt';
  requestpassmailfile:='requestpassmail.txt';
  changestringoptiondefault(optiontable^,maxoptiontable,'nick','A');
  changestringoptiondefault(optiontable^,maxoptiontable,'info','beware IRC authentication Service');

end;

function tauthbot.localloginchecks(sptr:tuser;parc:integer;parv:pparams;const msg:string) : boolean;
var
  a  : integer;
  pp : tplinklist;
  p  : taccount;
  s1 : string;
begin
  result := false;
  if locopt.securelogin then if not nickatservervar then begin
    //send(sendtalk+'To use LOGIN, you must /msg '+mybot.name+'@'+me.name);
    send(sendtalk+replacealias(reply_mustloginwithnickatserver,'%nickatserver%',mybot.name+'@'+me.name));
    exit;
  end;
  p := taccountUSINGserviceunit(srvunit).accountcore.findaccount(parv[1]);
  if assigned(p) then if locopt.maxlogins > 0 then if not isoper(sptr) then begin
    // if p is nil then we can just allow true to be returned knowing that our
    // caller will pick up on this issue later
    a := 0;
    pp := p.user;
    s1 := '';
    while pp <> nil do begin
      inc(a);
      s1 := s1 + ' '+nickuserhost(tuser(pp.p));
      pp := tplinklist(pp.next);
    end;
    if a >= locopt.maxlogins then begin
      //send(sendtalk+'AUTHENTICATION FAILED as '+p.name+'. Maximum concurrent logins exceeded.');
      send(sendtalk+replacealias(reply_loginfailedmaxloginsexceeded,'%account%',p.name));

      send(sendtalk+reply_currentsessions+s1);
      exit;
    end;
  end;

  result := true;
end;

procedure tauthbot.sendversionreply;
begin
  send(sendtalk+#1'VERSION '+versioninfostr+' '+versionstr+'. authentication service.'#1);
end;


procedure tauthbot.expireaccounts;
var
  ac,ac2:taccount;
  a:integer;
begin
  if unixtime and 1023 <> 0 then exit;
  if locopt.accountlifetime = 0 then exit;
  ac := taccountUSINGserviceunit(srvunit).accountcore.accountlist;
  while assigned(ac) do begin
    ac2 := taccount(ac.next);
    if ac.level <= 1 then begin
      a := ac.lastseents;
      if a = 0 then a := ac.lastmailts;
      if (a <> 0) then if a < irctime-locopt.accountlifetime then begin
        //logaction(nil,'account '+ac.name+' expired');
        logaction(nil,replacealias(log_accountexpired,'%account%',ac.name));
        linklistdel(tlinklist(taccountUSINGserviceunit(srvunit).accountcore.accountlist),tlinklist(ac));
        ac.destroy;
      end;
    end;
    ac := ac2;
  end;
end;

begin
  tauthbot.create;

end.
