{bot}
{BWORLD is an irc operator service, similar to UWorld.}

(*
 *  beware IRC services, bworldbot.pas
 *  Copyright (C) 2002 Bas Steendijk
 *
 *  modifications by peter green
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *)


unit bworldbot;

interface

uses
  buser  , bconsts , sysutils , pgtypes , accountUSINGbot , accountcore ,
  bstuff ;

const
  glinelevelsfile='bworld.levels.gline.ini';
  glistfile='bworld.gline.ini';
  jupelistfile='bworld.jupe.ini';
  exceptionfile='bworld.exception.ini';
  channelsfile='bworld.channels.ini';

type
  tbworldbot=class(taccountUSINGbot)
  public
    locopt:record
      //nick:string;
      //userid:string;
      //info:string;
      //operchannel:string;
      //operlevel:integer;
      firewall:boolean;
      clonelimit:integer;
      cloneduration:string;
      clonereason:string;
      globalaccounts:boolean;
      minlevel:integer;
    end;
    localaccountcore : taccountcore;
    constructor create;
    function ismortal(us:tuser):boolean;override;
    function denyaccess(us:tuser):boolean;override;

    procedure botinit;override;
    procedure botsave(saveall:boolean);override;
    procedure localtimehandler;override;
    procedure setupsrvunit;override;
    procedure localshutdown;override;
    procedure buildoptiontable;override;
    function getaccountcore : taccountcore;override;
    procedure sendversionreply;override;
    function localloginchecks(sptr:tuser;parc:integer;parv:pparams;const msg:string) : boolean ;override;
    function candeopk:boolean; override;
    function isregisteredchan(channel:string):boolean;override;
    procedure donewconfigchanges;override;
    procedure loadaccountdependent;override;
  end;

//procedure onsendburst(tag:taddrint);
//procedure ondisconnect(tag:taddrint);
//procedure onstartup(tag:taddrint);
//procedure bworldbotshutdown(tag:taddrint);
//procedure ontimer(tag:taddrint);
procedure onnewuser(us:tuser;tag:taddrint);
//procedure ondestroyuser(us:tuser;tag:taddrint);
//procedure onrehash(tag:taddrint);
function parseduration(s:string):integer;

(*procedure savecmd;
procedure loadcmd;*)
//function validcomname(s:string):boolean;

//procedure deauth(us:tuser);

//var
//  mybot:tuser;  {this unit has one bot, pointer to tuser for bot}

{==============================================================================}
//var
 // bworldbotobject : tbworldbot;
implementation

uses
  bconfig        , bservicemngr    , bparse         , bcmds        ,
  bchannel       , btime           , b_gline        , passcryp     ,
  bworldjupe     , blinklist       , bcrash         , bservunit    ,
  bworldchan     , bworldexception , unitbanmask    , boptiontable ,
  bsetcommand    , unitwritetxt    , bworldcommands , binipstuff   ,
  bworld_replies , generalreplies  ;


{centralized error replies}
function error_nosuchaccount(const name:string):string;
begin
  result := reply_nosuchaccount+' '+name;
end;

function error_nosuchchannel(const name:string):string;
begin
  result := reply_nosuchchannel+' '+name;
end;

function error_nosuchnick(const name:string):string;
begin
  result := reply_nosuchnick+' '+name;
end;

//type
  (*
  taccount=class
    name:string;
    info:string;
    password:string; {crypted password using salt MD5}
    level:integer;
    user:tuser; {who is logged in; only one for now, call to ondestroyuser is needed at the begin of tuser.destroy}
  end;
  *)
(*
var
  cmd:string; {currently called cmd}
  autosavenextts:integer;
*)
{level -1 = always allow, even if not logged in}


{
G-line rules:

- even a lower level ircop may be able to use GLINE
but short duration only
}

{const
  maxoptiontable=8;}

//var
  {config file options for this service unit}

  {
  optiontable:array[0..maxoptiontable] of Toptionentry=(
  (
  p:@locopt.nick;
  typ:opt_str;
  name:'nick';
  info:'BWorld bot''s nick';
  def_s:'B'),
  (
  p:@locopt.userid;
  typ:opt_str;
  name:'userid';
  info:'BWorld bot''s userid (empty for global userid setting)';
  def_s:''),
  (
  p:@locopt.info;
  typ:opt_str;
  name:'info';
  info:'BWorld bot''s realname';
  def_s:'beware IRC Operator Service'),
  (
  p:@locopt.operchannel;
  typ:opt_str;
  name:'operchannel';
  info:'BWorld bot event log channel';
  def_s:'#Admin'),
  (
  p:@locopt.operlevel;
  typ:opt_int;
  name:'OperLevel';
  info:'BWorld access level for opers who are not logged in';
  def_i:maxlevel div 10),
  (
  p:@locopt.firewall;
  typ:opt_bool;
  name:'firewall';
  info:'ignore (don''t reply) any message from someone who is not oper, and not logged in';
  def_b:true),
  (
  p:@locopt.clonelimit;
  typ:opt_int;
  name:'clonelimit';
  info:'maximum users from one IP before setting G-line';
  def_i:20),
  (
  p:@locopt.cloneduration;
  typ:opt_str;
  name:'cloneduration';
  info:'duration in seconds of clone auto G-line';
  def_s:'1h'),
  (
  p:@locopt.clonereason;
  typ:opt_str;
  name:'clonereason';
  info:'reason for clone G-line';
  def_s:'automatic clone ban')
  );
  }
  (*
  up:boolean;   {the service unit is enabled}

  srvunit:tserviceunit;
  currentoperchannel:string;
  sendtalk:string;
  prefix:string;  {the ":sender " part of a message sent by this bot}
  *)
function levelcontrol(mylevel,otherlevel:integer):boolean;
begin
  if mylevel >= maxlevel then begin
    result := mylevel >= otherlevel;
  end else begin
    result := mylevel > otherlevel;
  end;
end;

{function getaccountfromuser(us:tuser):tbworldaccount;
begin
  result := us.bottag[srvunit.num];
end;}

{function haslevel(us:tuser):integer;
var
  p:tbworldaccount;
begin
  result := -1;
  if isoper(us) then result := locopt.operlevel;
  p := getaccountfromuser(us);
  if p <> nil then begin
    if p.level > result then result := p.level;
  end;
end;}

{procedure logaction(sptr:tuser;s:string);
var
  from:string;
  p:tbworldaccount;
begin

  if sptr <> nil then begin
    from := nickuserhost(sptr);
    p := getaccountfromuser(sptr);
    if p <> nil then begin
      from := from + '['+p.name+']';
    end;
    from := from + ' ';
  end else begin
    from := '';
  end;

  if currentoperchannel <> '' then send(prefix+TOK_NOTICE+' '+currentoperchannel+' :'+from+s);
  filelog(bworldbotlogfile,from+s);
end; }

(*
procedure deauth(us:tuser);
var
  t:tbworldaccount;
begin
  t := us.bottag[srvunit.num];
  if t = nil then exit;
  assert(t.user = us,'bworld.deauth: account.user and user.account don''t match','');

  t.user := nil;
  us.bottag[srvunit.num] := nil;
end;
*)
{procedure deauth(us:tuser);
var
  t:tbworldaccount;
begin
  t := getaccountfromuser(us);
  if t = nil then exit;

  assert(t.removeuser(us),'BWorld.deauth: user not in account','');

  us.bottag[srvunit.num] := nil;
end;}


{function getloginname(us:tuser):string;
var
  t:taccount;
begin
  result := '';
  t := getaccountfromuser(us);
  if t = nil then exit;
  result := t.name;
end;}

function tbworldbot.ismortal(us:tuser):boolean;
begin
  result := locopt.firewall;
  if isoper(us) then result := false;
  //if taccountUSINGserviceunit(srvunit).accountcore.getaccountfromuser(us) <> nil then result := false;
  if haslevel(us) >= locopt.minlevel then result := false;
end;

function tbworldbot.denyaccess(us:tuser):boolean;
begin
  result :=  haslevel(us) < locopt.minlevel;
end;

procedure tbworldbot.botinit;
begin
  inherited botinit;
  {fill in some defaults in case they cant be read from config file}

  {optiontable_default(optiontable,maxoptiontable);
  optiontable_load(optiontable,maxoptiontable,configfile,cfgtag);

  loadcmd;
  loadbworldaccount(accountsfile);}
  loadgline(glistfile);
  
  loadexception(exceptionfile);

  {autosavenextts := unixtime+opt.autosave;}
  {loadjupe}
end;

procedure tbworldbot.botsave;
begin
  inherited botsave(saveall);
  //autosavenextts := unixtime+opt.autosave;
  savegline(glistfile);
  savechan(channelsfile,self);
{  savejupe(jupelistfile);}
  //savecmd;
  //savebworldaccount(accountsfile);
  saveexception(exceptionfile);
  //optiontable_save(optiontable,maxoptiontable,configfile,cfgtag);
end;

{procedure onsave(tag:taddrint);
begin
  logaction(nil,'Received SAVE signal');
  bworldbotsave;
end;}


















{============================================================================}
(*
procedure onprivmsg(nickatserver:boolean;sptr:tuser;target:tuser;s:string;tag:taddrint);
var
  parv:tparams;
  parc:integer;
  a,b:integer;
  bool:boolean;
begin
  parc := strtok(s,' ',@parv);
  cmd := ircupper(parv[0]);
  if cmd = '' then exit;
  sendtalk := sendtalkstr(mybot,sptr);
  b := -1;
  bool := ismortal(sptr);
  for a := 0 to botmaxcmd do begin
    if cmd = cmdtab[a].customcmd then begin
      if haslevel(sptr) >= cmdtab[a].level then begin
        if cmdtab[a].minparams > parc then begin
          if not ismortal(sptr) then send(sendtalk+{s+' '+}replacespecial(cmdtab[a].syntax,mybot.name,me.name,cmdtab[a].customcmd,#10+sendtalk));

        end else begin
          if @cmdtab[a].p <> nil then cmdtab[a].p(sptr,parc,@parv,s);

        end;
        b := 0;
      end else begin
        b := 1;
      end;
    end;
    if bool then exit; {LOGIN must be first entry of cmdtable}
  end;
  if b < 0 then begin

    {handle CTCP requests}
    if cmd[1] = #1 then begin
      if cmd = #1'VERSION'#1 then begin
        send(sendtalk+#1'VERSION '+versioninfostr+' '+versionstr+'. BWorld operator service.'#1);
        exit;
      end else
      if copy(cmd,1,5) = #1'PING' then begin
        send(sendtalk+#1'PING '+parv[1]);
        exit;
      end
    end;
    send(sendtalk+'Unknown command');
  end else if b = 1 then begin
    send(sendtalk+'No access');
  end;
end;
*)
(*
procedure onstartup;
begin
  if up then exit;
  up := true;
  currentoperchannel := '';
  bworldbotinit;
  mybot := addbot(srvunit,locopt.nick,locopt.userid,'',locopt.info,usermode_service or usermode_oper or usermode_invisible);
  prefix := sendprefixstr(mybot);
  if locopt.operchannel <> '' then begin
    bot_join(mybot,locopt.operchannel,true,globaldefaultts);
    sendparse(mybot.idstr+' '+TOK_MODE+' '+locopt.operchannel+' +ntsi');
    currentoperchannel := locopt.operchannel;
  end;
  bworldbotinit;
  logaction(nil,'startup');
end;
*)
{procedure ontimer;
begin
  if opt.autosave <> 0 then if (unixtime >= autosavenextts) then begin
    logaction(nil,'autosave');
    bworldbotsave;
  end;
  b_gline.timehandler;
end;}

procedure tbworldbot.localtimehandler;
begin
  b_gline.timehandler;
end;

procedure onnewuser;
var
  gl:tgline;
  s:string;
  s2:string;
  b:integer;
  ex:tban;
  bm:tbanmask;

begin
 with tbworldbot(tag) do begin
  {clone limit check}
  s := ircupper(us.userid+'@'+us.host);
  s2 := ircupper(us.userid+'@'+ircipbintostr(us.binip));


  {$ifdef ipv6}
  if (us.binip.ip6.u6_addr32[0] = 0) and (us.binip.ip6.u6_addr32[1] = 0)
  and (us.binip.ip6.u6_addr32[2] = 0) and (us.binip.ip6.u6_addr32[3] = 0) then exit;
  {$endif}
  if us.binip.ip = 0 then exit;

  if locopt.clonelimit <= 0 then exit;
  assert(us.ipcheck <> nil,'clone limit: us.ipcheck is not assigned','');
  b := locopt.clonelimit;

  if b > 0 then if us.ipcheck.online > b then begin
    {exception?}
    ex := exceptionlist;
    while ex <> nil do begin
      if maskmatch(ircupper(ex.mask),s2) then begin
        if ex.date > b then b := ex.date;
        if ex.date = 0 then b := maxlongint;
      end;
      ex := tban(ex.next);
    end;

    if us.ipcheck.online > b then begin
      logaction(nil,'Clone limit G-line on '+ircipbintostr(us.binip)+', '+inttostr(us.ipcheck.online)+' clones.');
      addgline('-clone','*@'+ircipbintostr(us.binip),parseduration(locopt.cloneduration),locopt.clonereason);
      exit;
    end;
  end;

  banmaskmake_oneuser(@bm,us.userid,us.host,us.binip);

  gl := tgline(glist);
  while gl <> nil do begin
    if banmaskmatch(@gl.m,@bm) then
    if gl.date >= irctime then
    if flag_isset(gl.flags,glineflag_active) then begin
      sendgline(gl);
      exit
    end;
    gl := tgline(gl.next);
  end;
 end;
end;
(*
procedure ondestroyuser;
begin
  deauth(us);
  {}
end;

procedure onsendburst;
begin
  {}
end;

procedure ondisconnect;
begin
  {}
end;

procedure onrehash;
begin
  if not up then exit;
  logaction(nil,'Received REHASH signal');
  bworldbotinit;
end;*)

procedure tbworldbot.localshutdown;
begin
  //if not up then exit;
  //inherited botshutdown;
  //up := false;

  //logaction(nil,'shutdown: '+shutdownreason);

  //bworldbotsave;

  cleargline;
  clearjupe;
  clearchan(self);
  //clearbworldaccount;

  //bot_quit(mybot,shutdownreason);
  //mybot := nil;
  //currentoperchannel := '';
end;

procedure tbworldbot.setupsrvunit;
begin
  inherited setupsrvunit;
  //srvunit := createserviceunit;
  srvunit.name := 'BWorld';
  //srvunit.onstartup := onstartup;
  //srvunit.onshutdown := bworldbotshutdown;
  //srvunit.onprivmsg := onprivmsg;
  //srvunit.ontimer := ontimer;
  //srvunit.onsave := onsave;
  srvunit.onnewuser := onnewuser;
  //srvunit.ondestroyuser := ondestroyuser;
  //srvunit.onrehash := onrehash;
  //if not registerserviceunit(srvunit) then srvunit.destroy;
end;




constructor tbworldbot.create;
begin
  inherited create;
  cmdtab := @bworldcommands.cmdtab;
  botmaxcmd := bworldcommands.botmaxcmd;
  buildsorted;
  commandsfile:='bworld.com.ini';
  configfile:='bworld.ini';
  cfgtag:='[bworld]';
  //accountsfile:='bworld.accounts.ini';

  botlogfile:='bworld.log';

  changestringoptiondefault(optiontable^,maxoptiontable,'nick','B');
  changestringoptiondefault(optiontable^,maxoptiontable,'info','beware IRC operator Service');
  changestringoptiondefault(optiontable^,maxoptiontable,'botmodes','idk');
  localaccountcore := taccountcore.create;
  with localaccountcore do begin
    mode := 1;
    accountsfile := 'bworld.accounts.ini';
  end;
end;

function parseduration(s:string):integer;
var
  b:integer;
  c:char;
begin
  c := s[length(s)];
  case c of
    'h':b := 3600;
    'd':b := 86400;
    'w':b := 86400*7;
    'm':b := 86400*30;
    'y':b := 86400*365;
    '0'..'9':b := 1;
  else
    b := 0;
  end;
  if b <> 1 then s := copy(s,1,length(s)-1);

  result := strtointdef(s,0)*b;
end;

procedure tbworldbot.buildoptiontable;
var
  startat : integer;
begin


  startat := maxoptiontable+1;
  inc(maxoptiontable,6);

  inherited buildoptiontable;
  with optiontable[startat] do begin
    p:=@locopt.firewall;
    typ:=opt_bool;
    name:='firewall';
    info:='ignore (don''t reply) any message from someone who is not oper, and not logged in';
    def_b:=true;
  end;
  inc(startat);
  with optiontable[startat] do begin
    p:=@locopt.clonelimit;
    typ:=opt_int;
    name:='clonelimit';
    info:='maximum users from one IP before setting G-line';
    def_i:=20
  end;
  inc(startat);
  with optiontable[startat] do begin
    p:=@locopt.cloneduration;
    typ:=opt_str;
    name:='cloneduration';
    info:='duration in seconds of clone auto G-line';
    def_s:='1h'
  end;
  inc(startat);
  with optiontable[startat] do begin
    p:=@locopt.clonereason;
    typ:=opt_str;
    name:='clonereason';
    info:='reason for clone G-line';
    def_s:='automatic clone ban'
  end;
  inc(startat);
  with optiontable[startat] do begin
    p:=@locopt.globalaccounts;
    typ:=opt_bool;
    name:='globalaccounts';
    info:='use global accounts';
    def_b:=false;
  end;
  inc(startat);
  with optiontable[startat] do begin
    p:=@locopt.minlevel;
    typ:=opt_int;
    name:='minlevel';
    info:='minimum level of user that can use bworld';
    def_i:=10;
  end;


end;

function tbworldbot.getaccountcore : taccountcore;
begin

  if locopt.globalaccounts then begin
    result := globalaccountcore;
  end else begin
    result := localaccountcore;
  end;
end;

procedure tbworldbot.sendversionreply;
begin
  send(sendtalk+#1'VERSION '+versioninfostr+' '+versionstr+'. BWorld operator service.'#1);
end;

function tbworldbot.localloginchecks(sptr:tuser;parc:integer;parv:pparams;const msg:string) : boolean;
var
  p  : taccount;
begin
  result := false;
  p := taccountUSINGserviceunit(srvunit).accountcore.findaccount(parv[1]);
  if assigned(p) then begin
    // if p is nil then we can just allow true to be returned knowing that our
    // caller will pick up on this issue later

    if (p.level < locopt.minlevel) and (haslevel(sptr)<locopt.minlevel) then begin
      if not ismortal(sptr) then send(sendtalk+replacealias(reply_authfailedleveltoolow,'%account%',p.name));
      exit;
    end;
  end;

  result := true;
end;

function tbworldbot.candeopk:boolean;
begin
  result := true;
end;

function tbworldbot.isregisteredchan(channel:string):boolean;
var
  gl,gl2:tchanmanage;
  s : string;
begin
  gl2 := tchanmanage(chanmanagelist);
  gl := nil;
  s := ircupper(channel);
  while gl2 <> nil do begin
    if (ircupper(gl2.name) = s) then begin
      gl := gl2;
      break;
    end;
    gl2 := tchanmanage(gl2.next);
  end;
  if gl = nil then begin
    result := false;
  end else begin
    result := true
  end;
end;

procedure tbworldbot.donewconfigchanges;
begin
  locopt.globalaccounts := true;
end;

procedure tbworldbot.loadaccountdependent;
begin
  loadchan(channelsfile,self);
end;

var
  bworldbotobject : tbworldbot;
begin
  //reg;
  bworldbotobject := tbworldbot.create;
 // writeln(longint(@(bworldbotobject.locopt.globalaccounts)));
end.
