(*
 *  beware IRC services, bworldommands.pas
 *  Copyright (C) 2002-2005 Bas Steendijk and Peter Green
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *)


unit bworldcommands;

interface
uses
    buser,
    accountUSINGbot,
    bstuff,
    accountcore,
    objbot,
    accountmanagecmds,
    botmanagecommands,
    logincmds,
    infocmds,
    chanpowercmds,
    binipstuff,
    bvaliddef;

{info commands}
//procedure priv_showcommands(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;botobject : taccountUSINGbot);
procedure priv_whois(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_findnum(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_lusers(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_chaninfo(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_mem(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);

{ircop commands}
procedure priv_kill(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_raw(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_opchan(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);



{gline management}
procedure priv_glist(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_gline(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_remgline(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_refreshg(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);

{jupe management}
(*
procedure priv_jupe(sptr:tuser;parc:integer;parv:pparams;msg:string);
procedure priv_unjupe(sptr:tuser;parc:integer;parv:pparams;msg:string);
*)
{procedure priv_rehash(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_set(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);}
//procedure priv_globalset(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
{procedure priv_save(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_restart(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_die(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_diebot(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);}
procedure priv_settime(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);

{own account}
{procedure priv_login(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_deauth(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_newpass(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
}
{global bot management}
{procedure priv_level(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_chcomname(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_chinfo(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_chsyntax(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
}
//procedure priv_mkpasswd(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);

{oper accounts management}
{procedure priv_addoper(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_deloper(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_operlist(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_operinfo(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_modoper(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
}
{channel management}
procedure priv_listchannels(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_addchannel(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_delchannel(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);

procedure priv_exceptionlist(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_addexception(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_delexception(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);

procedure priv_showclones(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);

procedure priv_mode(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);


const
  botmaxcmd=54;
//note minparams is matched against parc which includes the name of the parameter
//e.g. login example example parc=3
var

cmdtab:array[0..botmaxcmd] of tcmdtab=(
(
cmd:'LOGIN';
level:-1;
p:priv_login;
minparams:3;
info:'login to your account';
syntax:'%cmd% <IDnick> <password>'),
(
cmd:'DEAUTH';
level:0;
p:priv_deauth;
minparams:1;info:'log out';
syntax:'%cmd%'),
(
cmd:'HELP';
level:-1;
p:priv_showcommands;
minparams:1;
info:'list all commands available to you with info';
syntax:'%cmd% [<command>]'),
(
cmd:'MKPASSWD';
level:0;
p:priv_mkpasswd;
minparams:2;
info:'crypt a password';
syntax:'%cmd% <password>'),
(
cmd:'LUSERS';
level:0;
p:priv_lusers;
minparams:1;
info:'show number of users on the net';
syntax:'%cmd%'),
(
cmd:'WHOIS';
level:100;
p:priv_whois;
minparams:2;
info:'extended whois, including the secret channels someone is in';
syntax:'%cmd% <nick>'),
(
cmd:'TRANSLATE';
level:100;
p:priv_findnum;
minparams:2;
info:'convert names to/from numerics';
syntax:'%cmd% <nick>|<numeric>'),
(
cmd:'GLIST';
level:100;
p:priv_glist;
minparams:1;
info:'show G-lines';
syntax:'%cmd%'),
(
cmd:'CHANINFO';
level:100;
p:priv_chaninfo;
minparams:2;
info:'show complete information about a channel';
syntax:'%cmd% <channel>'),

(
cmd:'KILL';
level:200;
p:priv_kill;
minparams:3;
info:'Kill a user';
syntax:'%cmd% <nick> <reason>'),
(
cmd:'OPCHAN';
level:100;
p:priv_opchan;
minparams:3;
info:'Op someone in an opless channel';
syntax:'%cmd% <channel> <nick>'),
(
cmd:'INVITE';
level:200;
p:priv_invite;
minparams:1;
info:'Invite yourself to a channel';
syntax:'%cmd% [<channel>]'),

(
cmd:'GLINE';
level:300;
p:priv_gline;
minparams:4;
info:'Add a G-line';
syntax:'%cmd% <nick or mask> <duration> <reason>'),
(
cmd:'UNGLINE';
level:300;
p:priv_remgline;
minparams:2;
info:'Remove a G-line';
syntax:'%cmd% <mask>'),
(
cmd:'REFRESHG';
level:200;
p:priv_refreshg;
minparams:1;
info:'re-send all G-lines';
syntax:'%cmd%'),

(
cmd:'LISTCHANNELS';
level:100;
p:priv_listchannels;
minparams:1;
info:'list channels managed by BWorld';
syntax:'%cmd%'),
(
cmd:'ADDCHANNEL';
level:800;
p:priv_addchannel;
minparams:2;
info:'add channel managed by BWorld';
syntax:'%cmd% <channel> [<default modes>]'),
(
cmd:'DELCHANNEL';
level:800;
p:priv_delchannel;
minparams:2;
info:'remove a channel managed by BWorld';
syntax:'%cmd% <channel>'),

(*(cmd:'JUPE';level:800;p:priv_jupe),
(cmd:'UNJUPE';level:800;p:priv_unjupe),*)

(
cmd:'MODE';level:800;
p:priv_mode;
minparams:3;
info:'change channel modes';
syntax:'%cmd% <channel> <params>'),
(
cmd:'KICKALL';
level:400;
p:priv_kickall;
minparams:2;
info:'kick everyone in a channel';
syntax:'%cmd% <channel>'),
(
cmd:'OPALL';
level:400;
p:priv_opall;
minparams:2;
info:'op everyone in a channel';
syntax:'%cmd% <channel>'),
(
cmd:'DEOPALL';
level:400;
p:priv_deopall;
minparams:2;
info:'deop everyone in a channel';
syntax:'%cmd% <channel>'),
(
cmd:'CLEARMODES';
level:400;
p:priv_clearmode;
minparams:2;
info:'clear all modes on a modes';
syntax:'%cmd% <channel>'),
(
cmd:'CLEARBANS';
level:400;
p:priv_clearbans;
minparams:2;
info:'remove all bans on a channel';
syntax:'%cmd% <channel>'),
(
cmd:'OP';
level:400;
p:priv_op;
minparams:1;
info:'op someone in a channel';
syntax:'%cmd% [<channel>]'),
(
cmd:'DEOP';
level:400;
p:priv_deop;
minparams:1;
info:'deop someone on a channel';
syntax:'%cmd% [<channel>]'),

(
cmd:'SET';
level:1000;
p:priv_set;
minparams:2;
info:'view/change configuration of This bot';
syntax:'%cmd% <option> [<new value>|none]%newline%options:%options%';
extrareplaceproc:set_replace),
(
cmd:'GSET';
level:1000;
p:priv_globalset;
minparams:2;
info:'view/change configuration of the services server';
syntax:'%cmd% <option> [<new value>|none]%newline%options:%options%';
extrareplaceproc:globalset_replace),
(
cmd:'RSET';
level:1000;
p:priv_replyset;
minparams:2;
info:'view/change reply strings';
syntax:'%cmd% <reply name> [<new value>|none]'),
(
cmd:'SETTIME';
level:900;
p:priv_settime;
minparams:1;
info:'send settime message';
syntax:'%cmd%'),
(
cmd:'QUOTE';
level:950;
p:priv_raw;
minparams:2;
info:'send raw message';
syntax:'%cmd% <message>'),
{(
cmd:'REHASH';
level:900;
p:priv_rehash;
minparams:1;
info:'reload files of BWorld bot';
syntax:'%cmd%'),}
(
cmd:'SAVE';
level:900 ;
p:priv_save;
minparams:1;
info:'save files of BWorld bot';
syntax:'%cmd%'),
(
cmd:'SAVEALL';
level:900 ;
p:priv_saveall;
minparams:1;
info:'save files of all bots';
syntax:'%cmd%'),

(
cmd:'RESTART';
level:900;
p:priv_restart;
minparams:1;
info:'restart BWorld bot';
syntax:'%cmd%'),
(
cmd:'DIE';
level:900;
p:priv_die;
minparams:1;
info:'stop services server';
syntax:'%cmd%'),
(
cmd:'DIEBOT';
level:900;
p:priv_diebot;
minparams:1;
info:'stop BWorld bot';
syntax:'%cmd%'),
(
cmd:'CHLEVEL';
level:1000;p:priv_level;
minparams:1;
info:'show/change access levels of commands';
syntax:'%cmd%'),
(
cmd:'CHCOMNAME';
level:1000;
p:priv_chcomname;
minparams:3;
info:'change name of commands';
syntax:'%cmd% <old command name> <new command name>'),
(
cmd:'CHINFO';
level:1000;
p:priv_chinfo;
minparams:3;
info:'Changes the info field for a command.';
syntax:'%cmd% <command> <new info setting>'),
(
cmd:'CHSYNTAX';
level:1000;
p:priv_chsyntax;
minparams:3;
info:'Changes the syntax field for a command.';
syntax:'%cmd% <command> <new syntax setting>'),

(
cmd:'MEM';
level:900;
p:priv_mem;
minparams:1;
info:'show memory usage status';
syntax:'%cmd%'),
(
cmd:'EXCEPTIONLIST';
level:100;
p:priv_exceptionlist;
minparams:1;
info:'show exceptions of clone limit G-line check';
syntax:'%cmd%'),
(
cmd:'ADDEXCEPTION';
level:800;
p:priv_addexception;
minparams:3;
info:'add exception of clone limit check';
syntax:'%cmd% <mask> <new limit>'),
(
cmd:'DELEXCEPTION';
level:800;
p:priv_delexception;
minparams:2;
info:'remove exception of clone limit check';
syntax:'%cmd% <mask>'),

(
cmd:'ADDOPER';
level:1000;p:priv_adduser;
minparams:3;
info:'add BWorld account';
syntax:'%cmd% <IDnick> <level>'),
(
cmd:'DELOPER';
level:1000;
p:priv_deluser;
minparams:2;
info:'remove BWorld account';
syntax:'%cmd% <IDnick>'),
(
cmd:'MODOPER';
level:1000;
p:priv_moduser;
minparams:3;
info:'change BWorld account';
syntax:'%cmd% <IDnick> <command> [<param>]%newline%%cmd% commands: ADDMASK DELMASK NEWPASS LEVEL OPERONLY'),
(
cmd:'OPERLIST';
level:0;
p:priv_userlist;
minparams:1;
info:'list BWorld accounts';
syntax:'type /msg %nick% cmd% [<minlevel> [<maxlevel>]]'),
(
cmd:'OPERINFO';
level:0;
p:priv_userinfo;
minparams:2;
info:'show info about one BWorld account';
syntax:'%cmd% <IDnick>'),
(
cmd:'NEWPASS';
level:-1;
p:priv_newpass;
minparams:4;
info:'change your own password';
syntax:'%cmd% <old> <new> <new>'),
(
cmd:'SHOWCLONES';
level:100;
p:priv_showclones;
minparams:2;
info:'shows the number of clones a user has';
syntax:'%cmd% <nick>'),
(
cmd:'SAY';
level:1000;
p:priv_say;
minparams:3;
info:'makes the service talk';
syntax:'%cmd% <channel|nick> <message>'),
(
cmd:'WHOAMI';
level:1;
p:priv_whoami;
minparams:1;
info:'tells you about your own account';
syntax:'%cmd%'),
(
cmd:'START';
level:1000;
p:priv_start;
minparams:2;
info:'starts a bot';
syntax:'%cmd% <botname>'),
(
cmd:'STOP';
level:1000;
p:priv_stop;
minparams:2;
info:'stops a bot';
syntax:'%cmd% <botname>')

);


implementation
uses
  bchannel  , bparse          , bworldbot   , btime          , bcmds          ,
  bconsts   , b_gline         , bsetcommand , bconfig        , bworldchan     ,
  blinklist , bworldexception , unitbanmask , bworld_replies , generalreplies ;
{===================================================================== info commands}
(*
procedure priv_showcommands(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  a,b,c:integer;
  s:string;
begin
  parv[1] := ircupper(parv[1]);
  if parc >=2 then begin
    for a := 0 to botmaxcmd do begin
      if parv[1] = cmdtab[a].customcmd then begin
        if haslevel(sptr) >= cmdtab[a].level then begin

          send(sendtalk+{s+' '+}replacespecial(cmdtab[a].syntax,mybot.name,me.name,cmdtab[a].customcmd,#10+sendtalk));

          exit;
        end else begin

          send(sendtalk+'No access');
          exit;
        end;
      end;
    //if bool then exit; {LOGIN must be first entry of cmdtable}
    end;
  end;

  send(sendtalk+'The following commands are available to you:');
  send(sendtalk+'use /msg '+mybot.name+' <command> for help on a specific command');
  send(sendtalk+'--------------------------------------------');
  b := haslevel(sptr);

  c := 1;
  for a := 0 to botmaxcmd do if b >= cmdtab[a].level then begin
    if length(cmdtab[a].customcmd) > c then c := length(cmdtab[a].customcmd);
  end;

  for a := 0 to botmaxcmd do begin
    if b >= cmdtab[a].level then begin
{      s := s+cmdtab[a].customcmd+' ';
      if length(s) > 50 then begin
        send(sendtalk+s);
        s := '';
      end}
      s := cmdtab[a].customcmd;
      while length(s) < c do s := s + ' ';
      send(sendtalk+s+' '+replacespecial(cmdtab[a].info,mybot.name,me.name,cmdtab[a].customcmd,#10+sendtalk)+' '+inttostr(cmdtab[a].level));

      //send(sendtalk+s+' '+cmdtab[a].info+' '+inttostr(cmdtab[a].level));
    end;
  end;
{  if s <> '' then send(sendtalk+s);}
end;
*)
procedure priv_whois(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  s:string;
  us:tuser;
  uc:tuserchan;
  a:integer;
begin
  with tbworldbot(botobject) do begin
    {if (parv[1] = '') or (parc < 2) then begin
      send(sendtalk+cmd+' <nick>');
      exit;
    end;}

    us := findname(parv[1]);
    if us = nil then begin
      send(sendtalk+error_nosuchnick(parv[1]));
      exit
    end;
    logaction(sptr,cmd+' '+parv[1]);

    // this check is needed in case someone uses whoid on a server
    if assigned(us.ipcheck) then begin
      send(sendtalk+us.name+'!'+us.userid+'@'+us.host+' ['+ircipbintostr(us.binip)+'] '+us.fullname);

      send(sendtalk+'  '+us.idstr+' '+inttostr(us.ipcheck.online)+' '+inttostr(us.ts)+' ('+timestrshort(us.ts)+')');
    end else begin
      send(sendtalk+us.name+'  '+us.idstr);
    end;
    send(sendtalk+'  '+reply_bworldwhois_onserver+' '+tuser(us.server.us).name);
    if us.account <> '' then  send(sendtalk+'  '+reply_bworldwhois_account+' '+us.account);
    send(sendtalk+'  '+reply_bworldwhois_modes+usermodestr(us));
    s := '';
    uc := tuserchan(us.channel);
    while uc <> nil do begin
      s := s + ' ';

      for a := maxuserchanmodetable downto 0 do begin
        if flag_isset(uc.flags,userchanmodetable[a].flag) then begin
          s := s + userchanmodetable[a].prefix;
          break
        end;
      end;
      s := s + uc.ch.name;

      uc := tuserchan(uc.next);
      if length(s) > 400 then begin
        send(sendtalk+'  '+reply_bworldwhois_onchannels+s);
        s := '';
      end;
    end;
    if s <> '' then send(sendtalk+'  '+reply_bworldwhois_onchannels+s);
  end;
end;

procedure priv_findnum(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  us:tuser;
  bool:boolean;
begin
 with tbworldbot(botobject) do begin

  {if (parv[1] = '') or (parc < 2) then begin
    send(sendtalk+cmd+' <numnick>');
    exit;
  end; }
  bool := false;
  us := findnumeric(parv[1]);
  if us <> nil then begin
    send(sendtalk+us.idstr+' '+us.name);
    bool := true;
  end;

  us := findname(parv[1]);
  if us <> nil then begin
    send(sendtalk+us.idstr+' '+us.name);
    bool := true;
  end;

  if not bool then send(sendtalk+error_nosuchnick(parv[1]));
 end;
end;

procedure priv_lusers(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
begin
 with tbworldbot(botobject) do begin

  //send(sendtalk+'There are '+
  //inttostr(count.globalclients-count.invisible)+' users and '+
  //inttostr(count.invisible)+' invisible on '+
  //inttostr(count.globalservers)+' servers');
  send(sendtalk+replacealias(replacealias(replacealias(reply_bworldlusers_main,'%users%',inttostr(count.globalclients-count.invisible)),'%invisible%',inttostr(count.invisible)),'%servers%',inttostr(count.globalservers)));


  send(sendtalk+inttostr(count.globalclients)+' '+reply_bworldlusers_global);

  send(sendtalk+inttostr(count.oper)+' '+reply_bworldlusers_operators);
  send(sendtalk+inttostr(count.channels)+' '+reply_bworldlusers_channels);
 end;
end;

procedure priv_chaninfo(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  ch:tchannel;
  uc:tuserchan;
  s:string;
  ban:tban;
  a:integer;
begin
  with tbworldbot(botobject) do begin
    {if (parv[1] = '') or (parc < 2) then begin
      send(sendtalk+cmd+' <channel>');
      exit;
    end;}

    ch := findchan(parv[1]);
    if ch = nil then begin
      send(sendtalk+error_nosuchchannel(parv[1]));
      exit
    end;
    send(sendtalk+ch.name);
    send(sendtalk+'  '+reply_bworldchaninfo_ts+' '+inttostr(ch.ts)+' ('+timestrshort(ch.ts)+')');
    send(sendtalk+'  '+reply_bworldchaninfo_modes+chanmodestr(ch,true));
    send(sendtalk+'  '+inttostr(ch.usercount)+' '+reply_bworldchaninfo_usercount);

    s := '';
    uc := tuserchan(ch.user);
    while uc <> nil do begin
      s := s + ' ';
      for a := maxuserchanmodetable downto 0 do begin
        if flag_isset(uc.flags,userchanmodetable[a].flag) then begin
          s := s + userchanmodetable[a].prefix;
          break
        end;
      end;
      s := s + uc.us.name;
      uc := tuserchan(uc.next2);

      if length(s) > 400 then begin
        send(sendtalk+'  '+reply_bworldchaninfo_users+s);
        s := '';
      end;
    end;
    if s <> '' then send(sendtalk+'  '+reply_bworldchaninfo_users+s);


    s := '';
    ban := tban(ch.banlist);
    while ban <> nil do begin
      s := s + ' ';
      s := s + ban.mask;
      ban := tban(ban.next);

      if length(s) > 400 then begin
        send(sendtalk+'  '+reply_bworldchaninfo_bans+s);
        s := '';
      end;
    end;
    if s <> '' then send(sendtalk+'  '+reply_bworldchaninfo_bans+s);
  end;
end;

{$ifdef fpc}
  {$ifdef ver1_0}
    {$define fpcbefore195}
  {$endif}
  {$ifdef ver1_9_4}
    {$define fpcbefore195}
  {$endif}
{$endif}

procedure priv_mem(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  {$ifdef fpcbefore195}
    hs:tmemorymanager;

  {$else}
    hs:theapstatus;
  {$endif}
begin
 with tbworldbot(botobject) do begin

  {$ifdef fpcbefore195}
    getmemorymanager(hs);

    send(sendtalk+inttostr(hs.heapsize()-memavail));
  {$else}

    
    
    {$ifdef fpc}
      getheapstatus(hs);
      send(sendtalk+inttostr(hs.CurrHeapUsed));
    {$else}
      hs := getheapstatus;
      send(sendtalk+inttostr(hs.totalallocated));
    {$endif}  
  {$endif}
 end;
end;

{===================================================================== ircop commands}
procedure priv_kill(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  us:tuser;
  s:string;
begin
 with tbworldbot(botobject) do begin

  {if (parv[2] = '') or (parc < 3) then begin
    send(sendtalk+cmd+' <nick> <reason>');
    exit;
  end;}
  us := findnick(parv[1]);
  if us = nil then begin
    send(sendtalk+error_nosuchnick(parv[1]));
    exit;
  end;
  if flag_isset(us.modeflag,usermode_service) then begin
    send(sendtalk+reply_cantkillaservice);
    exit;
  end;
  s := copy(msg,pos(' ',msg)+1,500);
  s := copy(s,pos(' ',s)+1,500);
  logaction(sptr,cmd+' '+us.name+' ('+s+')');
  sendkill(us,mybot.name,s);
 end;
end;

procedure priv_raw(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  s:string;
begin
 with tbworldbot(botobject) do begin

  {if (parv[1] = '') or (parc < 2) then begin
    send(sendtalk+cmd+' <message>');
    exit;
  end;}
  s := copy(msg,pos(' ',msg)+1,500);
  logaction(sptr,cmd+' '+s);
  sendparse(s);
 end;
end;


procedure priv_opchan(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  us:tuser;
  uc:tuserchan;
  ch:tchannel;
begin
 with tbworldbot(botobject) do begin

  {if (parv[2] = '') or (parc < 3) then begin
    send(sendtalk+cmd+' <channel> <nick>');
    exit;
  end;}

  ch := findchan(parv[1]);
  if ch = nil then begin
    send(sendtalk+error_nosuchchannel(parv[1]));
    exit;
  end;

  us := findname(parv[2]);
  if us = nil then begin
    send(sendtalk+error_nosuchnick(parv[2]));
    exit;
  end;

  if getuserchan(us,ch) = nil then begin
    send(sendtalk+reply_usernotinchannel);
    exit;
  end;

  {is opless?}
  uc := tuserchan(ch.user);
  while uc <> nil do begin
    if flag_isset(uc.flags,userchanflag_op) then begin
      //send(sendtalk+'Channel '+ch.name+' is NOT opless');
      send(sendtalk+replacealias(reply_channelnotopless,'%channel%',ch.name));
      exit;
    end;
    uc := tuserchan(uc.next2);
  end;

  logaction(sptr,cmd+' '+parv[1]+' '+parv[2]);

  sendparse(me.idstr+' '+TOK_MODE+' '+ch.name+' +o '+us.idstr);
  //send(sendtalk+'I opped '+us.name+' on '+ch.name);
  send(sendtalk+replacealias(replacealias(reply_opchan,'%nick%',us.name),'%channel%',ch.name));
 end;
end;







{============================================================================ GLINE}



function lastparam(parv:pparams;parc,first:integer):string;
var
  a:integer;
begin
  result := '';
  for a := first to parc-1 do begin
    if result <> '' then result := result + ' ';
    result := result +parv[a];
  end;
end;


procedure priv_glist(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
begin
 with tbworldbot(botobject) do begin

  mc_gline(mybot,sptr,parc,parv);
 end;
end;

procedure priv_gline(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  s,sender,mask:string;
  ts:integer;
  us:tuser;
begin
 with tbworldbot(botobject) do begin

  {if (parv[3] = '') or (parc < 4) then begin
    send(sendtalk+cmd+' <nick or mask> <duration> <reason>');
    exit;
  end;}

  {if its a nick make it a host here}
  mask := parv[1];
  us := findnick(mask);
  if us <> nil then begin
    mask := '*@'+ircipbintostr(us.binip);
  end;

  if not ischanprefix(mask[1]) then
  if not validglinemask(mask) then begin
    send(sendtalk+reply_invalidmask);
    exit;
  end;

  ts := parseduration(parv[2]);
  if ts <= 0 then exit;

  s := lastparam(parv,parc,3);

  if not validglinereason(s) then begin
    send(sendtalk+reply_gline2words);
    exit;
  end;
  logaction(sptr,cmd+' '+parv[1]+' '+parv[2]+' ('+s+')');

  sender := getloginname(sptr);
  if sender = '' then sender := nickuserhost(sptr);

  addgline(sender,mask,ts,s);
 end;
end;

procedure priv_remgline(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  gl:tgline;
begin
 with tbworldbot(botobject) do begin

  {if (parv[1] = '') or (parc < 2) then begin
    send(sendtalk+cmd+' <mask>');
    exit;
  end;}

  if not ischanprefix(parv[1,1]) then validglinemask(parv[1]);
  gl := findgline(ircupper(parv[1]));
  if gl = nil then begin
    send(sendtalk+reply_nosuchgline);
    exit;
  end;

  logaction(sptr,cmd+' '+parv[1]+' ('+gl.reason+')');
  delgline(sptr,parv[1]);
 end;
end;


procedure priv_refreshg(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  gl:tgline;
begin
 with tbworldbot(botobject) do begin

  logaction(sptr,cmd);
  gl := tgline(glist);
  while gl <> nil do begin
    sendgline(gl);
    gl := tgline(gl.next);
  end;
  gl := tgline(badchanglist);
  while gl <> nil do begin
    sendgline(gl);
    gl := tgline(gl.next);
  end;
 end;
end;

{========================================================================== JUPE}

(*
procedure priv_jupe(sptr:tuser;parc:integer;parv:pparams;msg:string);
begin
  send(sendtalk+'jupe code not implemented yet');
end;

procedure priv_unjupe(sptr:tuser;parc:integer;parv:pparams;msg:string);
begin
  send(sendtalk+'jupe code not implemented yet');
end;
*)

{procedure priv_rehash(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
begin
  logaction(sptr,cmd);
  bworldbotinit;
end;

procedure priv_set(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  s:string;
begin
  setcommand(sptr,parc,parv,msg,bworldbot.optiontable,bworldbot.maxoptiontable,sendtalk,cmd,s);
  if s <> '' then logaction(sptr,s);
end;}


(*
procedure priv_save(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
begin
  logaction(sptr,cmd);
  bworldbotsave;
end;

procedure priv_restart(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
begin
  logaction(sptr,cmd);
  bworldbotshutdown(srvunit.tag);
  onstartup(srvunit.tag);
end;

procedure priv_die(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  a:integer;
begin
  logaction(sptr,cmd);

  shutdownreason := '';
  for a := 1 to parc-1 do begin
    if shutdownreason <> '' then shutdownreason := shutdownreason + ' ';
    shutdownreason := shutdownreason+parv[a];
  end;

  {onshutdown;}
  {die does global shutdown atm}
  globalshutdown;
  halt;
end;

procedure priv_diebot(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  a:integer;
begin
  logaction(sptr,cmd);

  shutdownreason := '';
  for a := 1 to parc-1 do begin
    if shutdownreason <> '' then shutdownreason := shutdownreason + ' ';
    shutdownreason := shutdownreason+parv[a];
  end;

  bworldbotshutdown(srvunit.tag);
end;
*)
procedure priv_settime(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
begin
 with tbworldbot(botobject) do begin

  logaction(sptr,cmd);
  send(me.idstr+' '+TOK_SETTIME+' :'+inttostr(irctime));
 end;
end;


{=====================================================own account}
(*
procedure priv_login(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
const
  loginfailed='Login failed';
var
  a:integer;
  p:tbworldaccount;
  sl:tstringlinklist;
  s1,s2,s3:string;

procedure failed;
begin
  if not ismortal(sptr) then send(sendtalk+loginfailed);
end;

begin
  {
  check:
  - is already logged in to anything
  - someone is already logged in to account
  - is ircop
  - mask
  - password.

  then associate user with account and account with user
  }

  if getaccountfromuser(sptr) <> nil then begin
    send(sendtalk+'You are already logged in, DEAUTH first.');
    exit;
  end;

  {if (parv[2] = '') or (parc < 3) then begin
    if not ismortal(sptr) then send(sendtalk+cmd+' <IDnick> <password>');
    exit;
  end;}

  p := findbworldaccount(parv[1]);
  if p = nil then begin
    failed;
    exit;
  end;

  {if operonly: check}
  if not isoper(sptr) then if p.operonly then begin
    logaction(sptr,'Failed login to '+p.name+': not IRCop');
    failed;
    exit;
  end;

  s1 := ircupper(sptr.name+'!'+sptr.userid+'@'+sptr.host);
  s2 := ircupper(sptr.name+'!'+sptr.userid+'@'+ipbintostr(sptr.binip));
  sl := p.mask;
  a := 0;
  while sl <> nil do begin
    s3 := ircupper(sl.s);
    if maskmatch(s3,s1) or maskmatch(s3,s2) then begin
      a := 1;
      break;
    end;
    sl := tstringlinklist(sl.next);
  end;
  if a = 0 then begin
    logaction(sptr,'Failed login to '+p.name+': mask does not match');
    failed;
    exit;
  end;

  if (p.password = '') then begin
    logaction(sptr,'Failed login to '+p.name+': account disabled.');
    failed;
    exit;
  end;

  if (not passmatch(parv[2],p.password)) or (p.password = '') then begin
    logaction(sptr,'Failed login to '+p.name+': password incorrect');
    failed;
    exit;
  end;

  sptr.bottag[srvunit.num] := p;
  p.adduser(sptr);
  logaction(sptr,'LOGIN');
  send(sendtalk+'Login OK');
end;

procedure priv_deauth(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
begin

  if getaccountfromuser(sptr) = nil then begin
    send(sendtalk+'You are not logged in.');
    exit;
  end;

  deauth(sptr);
  send(sendtalk+'You are logged off.');
end;
procedure priv_newpass(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  p:tbworldaccount;

begin
  {if (parv[3] = '') or (parc < 4) then begin
    send(sendtalk+cmd+' <old> <new> <new>');
    exit;
  end;}

  p := getaccountfromuser(sptr);
  if p = nil then begin
    send(sendtalk+'You are not logged in.');
    exit;
  end;

  if (not passmatch(parv[1],p.password)) or (p.password = '') then begin
    send(sendtalk+'password incorrect');
    exit;
  end;

  if (parv[2] <> parv[3]) then begin
    send(sendtalk+'new password mismatch');
    exit;
  end;

  p.password := passnewcrypt(parv[3]);

  logaction(sptr,'NEWPASS');
  send(sendtalk+'Your password has been changed.');
end;
*)
{=======================================================================commands management}
(*
function validcomname(s:string):boolean;
var
  a:integer;
begin
  result := false;
  if (length(s) > 15) or (s = '') then exit;
  for a := 1 to length(s) do if not (s[a] in ['A'..'Z']) then exit;
  result := true;
end;

procedure priv_level(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  a,b:integer;
  s:string;
begin
  if (parc < 2) or (parv[1] = '') then begin
    s := '';
    for a := 0 to botmaxcmd do begin
      s := s + cmdtab[a].cmd+'='+inttostr(cmdtab[a].level)+'    ';
      if length(s) > 50 then begin
        send(sendtalk+s);
        s := '';
      end;
    end;
    if s <> '' then send(sendtalk+s);
    exit
  end;
  parv[1] := ircupper(parv[1]);
  for a := 0 to botmaxcmd do begin
    if cmdtab[a].cmd = parv[1] then begin
      if (parc > 2) and (parv[2] <> '') then
      b := strtointdef(parv[2],-2)
      else b := -2;
      if b > -2 then begin
        logaction(sptr,cmd+' '+cmdtab[a].cmd+' '+inttostr(cmdtab[a].level)+' -> '+inttostr(b));
        cmdtab[a].level := b;
      end else begin
        send(sendtalk+cmdtab[a].cmd+'='+inttostr(cmdtab[a].level));
      end;
      exit;
    end;
  end;
  send(sendtalk+'command not found: '+parv[1]);
end;
(*
procedure savecmd;
var
  t:textfile;
  a:integer;
begin
  if not openforwrite(t,commandsfile) then exit;
  writeln(t,'[bworld.commands]');
  for a := 0 to botmaxcmd do begin
    writeln(t,'name='+cmdtab[a].cmd);
    writeln(t,'customname='+cmdtab[a].customcmd);
    writeln(t,'level='+inttostr(cmdtab[a].level));
    writeln(t,'enabled='+inttostr(ord(cmdtab[a].enabled)));
    writeln(t,'info='+cmdtab[a].info);
    writeln(t,'syntax='+cmdtab[a].syntax);
    writeln(t);
  end;
  closefile(t);
end;

var
  currentloadcmd:integer;

procedure loadcmdproc(sv,sn:string);
var
  a:integer;
begin
  if sv = 'NAME' then begin
    sn := ircupper(sn);
    currentloadcmd := -1;
    for a := 0 to botmaxcmd do if cmdtab[a].cmd = sn then begin
      currentloadcmd := a;
      exit;
    end;
  end else if sv = 'CUSTOMNAME' then begin
    if currentloadcmd <> -1 then begin
      sn := ircupper(sn);
      if validcomname(sn) then cmdtab[currentloadcmd].customcmd := sn;
    end;
  end else if sv = 'LEVEL' then begin
    if currentloadcmd <> -1 then begin
      cmdtab[currentloadcmd].level := strtointdef(sn,maxlevel);
    end;
  end else if sv = 'ENABLED' then begin
    if currentloadcmd <> -1 then begin
      cmdtab[currentloadcmd].enabled := sn = '1';
    end;
  end else if sv = 'INFO' then begin
    if currentloadcmd <> -1 then begin
      cmdtab[currentloadcmd].info := sn;
    end;
  end else if sv = 'SYNTAX' then begin
    if currentloadcmd <> -1 then begin
      cmdtab[currentloadcmd].syntax := sn;
    end;
  end;

end;

procedure loadcmd;
var
  a:integer;
begin
  currentloadcmd := -1;
  for a := 0 to botmaxcmd do begin
    cmdtab[a].customcmd := cmdtab[a].cmd;
    cmdtab[a].enabled := true;
  end;
  readcfg(commandsfile,@loadcmdproc);
end;

procedure priv_chcomname(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  a:integer;
begin
  {if (parc < 3) or (parv[2] = '') then begin
    send(sendtalk+cmd+' <old command name> <new command name>');
    exit
  end;}
  parv[1] := ircupper(parv[1]);
  parv[2] := ircupper(parv[2]);

  {check for parv[2] be a valid command (that is, easy to type)}

  if not validcomname(parv[2]) then begin
    send(sendtalk+'bad command name');
    exit
  end;
  for a := 0 to botmaxcmd do begin
    if cmdtab[a].customcmd = parv[2] then begin
      send(sendtalk+'command '+parv[2]+' already exists, can''t change.');
      exit;
    end;
  end;
  for a := 0 to botmaxcmd do begin
    if cmdtab[a].customcmd = parv[1] then begin
      logaction(sptr,cmd+' '+cmdtab[a].customcmd+' '+parv[2]);
      cmdtab[a].customcmd := parv[2];
      exit;
    end;
  end;
  send(sendtalk+'command not found: '+parv[1]);
end;
procedure priv_chinfo(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  a:integer;
  s:string;
begin
  s := copy(msg,pos(' ',msg)+1,500);
  s := copy(s,pos(' ',s)+1,500);

  parv[1] := ircupper(parv[1]);
  for a := 0 to botmaxcmd do begin
    if cmdtab[a].customcmd = parv[1] then begin
      logaction(sptr,cmd+' '+cmdtab[a].customcmd+' '+s);
      cmdtab[a].info := s;
      exit;
    end;
  end;
  send(sendtalk+'command not found: '+parv[1]);
end;

procedure priv_chsyntax(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  a:integer;
  s:string;
begin
  s := copy(msg,pos(' ',msg)+1,500);
  s := copy(s,pos(' ',s)+1,500);

  parv[1] := ircupper(parv[1]);
  for a := 0 to botmaxcmd do begin
    if cmdtab[a].customcmd = parv[1] then begin
      logaction(sptr,cmd+' '+cmdtab[a].customcmd+' '+s);
      cmdtab[a].syntax := s;
      exit;
    end;
  end;
  send(sendtalk+'command not found: '+parv[1]);
end;
*)
(*
procedure priv_mkpasswd(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
begin
  {if (parc < 2) or (parv[1] = '') then begin
    send(sendtalk+cmd+' <password>');
    exit;
  end;}
  send(sendtalk+passnewcrypt(parv[1]));
end;
*)

{========================================================================oper account}
(*
procedure priv_addoper(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  p:tbworldaccount;
  s:string;
  a:integer;
begin
  {if (parc < 3) or (parv[2] = '') then begin
    send(sendtalk+cmd+' <IDnick> <level>');
    exit
  end;}

  s := convertaccountname(parv[1]);

  if not validaccountname(s) then begin
    send(sendtalk+'invalid IDnick');
    exit
  end;
  a := strtointdef(parv[2],-1);
  if a < 0 then begin
    send(sendtalk+'invalid level');
    exit;
  end;
  p := findbworldaccount(parv[1]);

  if p <> nil then begin
    send(sendtalk+'account '+p.name+' already exists.');
    exit;
  end else begin
    if not levelcontrol(haslevel(sptr),a) then begin
      if a > haslevel(sptr) then begin
        send(sendtalk+'can''t add an account with this level.');
        exit;
      end;
    end;
    addbworldaccount(parv[1],a);
    logaction(sptr,cmd+' '+parv[1]+' '+inttostr(a));
  end;
end;

procedure priv_deloper(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  p:tbworldaccount;
begin
  {if (parc < 2) or (parv[1] = '') then begin
    send(sendtalk+cmd+' <IDnick>');
    exit
  end;}
  p := findbworldaccount(parv[1]);
  if p = nil then begin
    send(sendtalk+error_nosuchaccount(parv[1]));
    exit;
  end;

  if not levelcontrol(haslevel(sptr),p.level) then begin
    send(sendtalk+'No access to delete an account with this level');
    exit;
  end;

  logaction(sptr,cmd+' '+p.name);
  linklistdel(tlinklist(bworldaccountlist),tlinklist(p));
  p.destroy;
  {}
end;

procedure priv_operlist(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  p:tbworldaccount;
  s:string;
begin
  p := bworldaccountlist;
  send(sendtalk+'  IDnick        level    online');
  while p <> nil do begin
    s :=  '    '+p.name+' ';
    while length(s) < 16 do s := s + ' ';
    s := s + inttostr(p.level)+' ';
    while length(s) < 25 do s := s + ' ';
    if p.user <> nil then begin
      s := s + tuser(p.user.p).name;
    end else begin
      s := s + '-';
    end;
    send(sendtalk+s);
    p := tbworldaccount(p.next);
  end;
  send(sendtalk+'--- End of list ---');
  {}
end;

procedure priv_operinfo(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  p:tbworldaccount;
  s:string;
  sl:tstringlinklist;
  pp:tplinklist;
begin
  {if (parc < 2) or (parv[2] = '1') then begin
    send(sendtalk+cmd+' <IDnick>');
    exit;
  end;}
  p := findbworldaccount(parv[1]);
  if p = nil then begin
    send(sendtalk+error_nosuchaccount(parv[1]));
    exit;
  end;
  send(sendtalk+'  Name: '#2+p.name+#2'    Level: '#2+inttostr(p.level)+#2);
  sl := p.mask;
  if sl <> nil then begin
    s := '';
    while (sl <> nil) do begin
      s := s + ' '+sl.s;
      sl := tstringlinklist(sl.next);
      if length(s) > 450 then begin
        send(sendtalk+'  masks:'#2+s);
        s := '';
      end;
    end;
    if s <> '' then send(sendtalk+'  masks:'#2+s);
  end else begin
    send(sendtalk+'  no masks.');
  end;

  if p.user = nil then begin
    send(sendtalk+'  Not logged in.');
  end else begin
    pp := p.user;
    while pp <> nil do begin
      send(sendtalk+'  Logged in: '#2+nickuserhost(tuser(pp.p)));
      pp := tplinklist(pp.next);
    end;
  end;

  if p.operonly then send(sendtalk+'  Must be IRCop to log in');
  if p.password = '' then send(sendtalk+'  Account disabled.');

  send(sendtalk+'--- End of info ---');
  {}
end;
procedure priv_modoper(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  p:tbworldaccount;
  s,subcmd:string;
  a:integer;
begin
  if (parc < 3) or (parv[2] = '') then begin
    send(sendtalk+cmd+' <IDnick> <command> [<param>]');
    send(sendtalk+cmd+' commands: ADDMASK DELMASK NEWPASS LEVEL OPERONLY');
    exit
  end;
  p := findbworldaccount(parv[1]);
  if p = nil then begin
    send(sendtalk+error_nosuchaccount(parv[1]));
    exit;
  end;

  if not levelcontrol(haslevel(sptr),p.level) then begin
    send(sendtalk+'No access to modifying an account with this level');
    exit;
  end;

  subcmd := ircupper(parv[2]);
  if subcmd = 'ADDMASK' then begin
    for a := 3 to parc-1 do begin
      s := cookmask(parv[a]);
      if not validmask(s) then begin
        send(sendtalk+'invalid mask');
      end else begin
        if p.addmask(s) then begin
          logaction(sptr,cmd+' '+subcmd+' '+p.name+' '+s);
        end else begin
          send(sendtalk+'mask already exists');
        end;
      end;
    end;
  end else if subcmd = 'DELMASK' then begin
    for a := 3 to parc-1 do begin
      s := cookmask(parv[a]);
      if p.delmask(s) then begin
        logaction(sptr,cmd+' '+subcmd+' '+p.name+' '+s);
      end else begin
        send(sendtalk+'mask does not exist');
      end;
    end;
  end else if pos('PASS',subcmd) <> 0 then begin
    if parv[3] = '' then begin
      logaction(sptr,'Account '+p.name+' disabled.');
      p.password := '';
    end else begin
      logaction(sptr,cmd+' NEWPASS '+p.name);
      if ircupper(parv[4])='PRECRYPT' then begin
        p.password := parv[3];
      end else begin
        p.password := passnewcrypt(parv[3]);
      end;
    end;
  end else if subcmd = 'LEVEL' then begin
    a := strtointdef(parv[3],-1);
    if a >= 0 then begin
      if not levelcontrol(haslevel(sptr),a) then begin
        send(sendtalk+'can''t change level to this');
        exit;
      end;
      logaction(sptr,cmd+' LEVEL '+p.name+' '+inttostr(p.level)+' -> '+inttostr(a));
      p.level := a;
    end;
  end else if subcmd = 'OPERONLY' then begin
    s := ircupper(parv[3]);
    if ((s = 'ON') or (s = '1')) and (not p.operonly) then begin
      logaction(sptr,cmd+' OPERONLY '+p.name+' ON');
      p.operonly := true
    end else if ((s = 'OFF') or (s = '0')) and (p.operonly) then begin
      logaction(sptr,cmd+' OPERONLY '+p.name+' OFF');
      p.operonly := false ;
    end;
  end else begin
    send(sendtalk+'invalid command');
  end;
end;
*)
{======================================================================channel management}

procedure priv_listchannels(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  gl:tchanmanage;
begin
 with tbworldbot(botobject) do begin

  //send(sendtalk+'Channels managed by '+mybot.name);
  //send(sendtalk+'name        default modes       added by');
  send(sendtalk+replacealias(replacealias(reply_listchannelstitle,'%botname%',mybot.name),'%newline%',#10+sendtalk));
  gl := tchanmanage(chanmanagelist);
  while gl <> nil do begin
    send(sendtalk+'  '+gl.name+'      '+gl.defaultmodes+'      '+gl.sender);
    gl := tchanmanage(gl.next);
  end;
 end;
end;

procedure priv_addchannel(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  s:string;
  a,b:integer;
  gl,gl2:tchanmanage;
  ch:tchannel;
begin
 with tbworldbot(botobject) do begin

  {if (parv[1] = '') or (parc < 2) then begin
    send(sendtalk+cmd+' <channel> [<default modes>]');
    exit;
  end;}
  s := ircupper(parv[1]);

  {valid name?}
  b := 0;
  if length(s) > 50 then b := 1;
  if s[1] <> '#' then b := 1;
  if b = 0 then begin
    for a := 2 to length(s) do if s <= #32 then b := 1;
  end;
  if b <> 0 then begin
    send(sendtalk+reply_invalidchannelname);
    exit;
  end;

  {channel already exists?}
  gl2 := tchanmanage(chanmanagelist);
  gl := nil;
  while gl2 <> nil do begin
    if (ircupper(gl2.name) = s) then begin
      gl := gl2;
      break;
    end;
    gl2 := tchanmanage(gl2.next);
  end;
  if gl = nil then begin
    gl := tchanmanage.create;
    linklistadd(tlinklist(chanmanagelist),tlinklist(gl));
  end;
  gl.name := parv[1];
  gl.defaultmodes := '+nt';
  gl.sender := getloginname(sptr);
  if gl.sender = '' then gl.sender := nickuserhost(sptr);

  {channel exists?}
  ch := findchan(gl.name);
  if ch <> nil then gl.ts := ch.ts else gl.ts := irctime;

  if (parc >= 3) then if parv[2] <> '' then if parv[2,1] = '+' then begin
    gl.defaultmodes := parv[2];
  end;
  sendparse(mybot.idstr+' '+TOK_CREATE+' '+gl.name+' :'+inttostr(gl.ts));
  sendparse(mybot.idstr+' '+TOK_MODE+' '+gl.name+' :'+gl.defaultmodes);

  logaction(sptr,cmd+' '+parv[1]+' '+parv[2]);
 end;
end;

procedure priv_delchannel(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  s:string;
  gl,gl2:tchanmanage;
begin
 with tbworldbot(botobject) do begin

  {if (parv[1] = '') or (parc < 2) then begin
    send(sendtalk+cmd+' <channel>');
    exit;
  end;}
  s := ircupper(parv[1]);

  {channel exists?}
  gl2 := tchanmanage(chanmanagelist);
  gl := nil;
  while gl2 <> nil do begin
    if (ircupper(gl2.name) = s) then begin
      gl := gl2;
      break;
    end;
    gl2 := tchanmanage(gl2.next);
  end;
  if gl = nil then begin
    send(sendtalk+error_nosuchchannel(parv[1]));
    exit;
  end;
  logaction(sptr,cmd+' '+gl.name);
  if ircupper(gl.name) <> ircupper(opt.operchannel) then sendparse(mybot.idstr+' '+TOK_PART+' '+gl.name+' :');
  linklistdel(tlinklist(chanmanagelist),gl);
  gl.destroy;
 end;
end;


{========================================================================= misc}

{
onsavefile(from:tuser;,filename:string)

can be used to have multiple bots use the same file for something;
one bot saves, another bot loads

}








procedure priv_exceptionlist(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  p:tban;
  s:string;
begin
 with tbworldbot(botobject) do begin

  p := exceptionlist;
  //send(sendtalk+'clone limit exception list');
  //send(sendtalk+'  IP mask                     new limit  sender');
  send(sendtalk+replacealias(reply_exceptionlisttile,'%newline%',#10+sendtalk));
  while p <> nil do begin
    s :=  '    '+p.mask+' ';
    while length(s) < 32 do s := s + ' ';
    s := s + inttostr(p.date)+' ';
    while length(s) < 43 do s := s + ' ';
    s := s + p.sender;
    send(sendtalk+s);
    p := tban(p.next);
  end;
  send(sendtalk+reply_endoflist);
  {}
 end;
end;

procedure priv_addexception(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  s:string;
  gl,gl2:tban;
begin
 with tbworldbot(botobject) do begin

  {if (parv[2] = '') or (parc < 3) then begin
    send(sendtalk+cmd+' <mask> <new limit>');
    exit;
  end;}

  if pos('@',parv[1]) = 0 then parv[1] := '*@'+parv[1];

  s := ircupper(parv[1]);

  if not validmask(s) then begin
    send(sendtalk+reply_invalidmask);
    exit;
  end;

  {entry already exists?}
  gl2 := tban(exceptionlist);
  gl := nil;
  while gl2 <> nil do begin
    if (ircupper(gl2.mask) = s) then begin
      gl := gl2;
      break;
    end;
    gl2 := tban(gl2.next);
  end;
  if gl = nil then begin
    gl := tban.create;
    linklistadd(tlinklist(exceptionlist),tlinklist(gl));
  end;
  gl.mask := parv[1];
  gl.date := strtointdef(parv[2],0);
  gl.sender := getloginname(sptr);
  if gl.sender = '' then gl.sender := nickuserhost(sptr);

  logaction(sptr,cmd+' '+parv[1]+' '+parv[2]);
 end;
end;

procedure priv_delexception(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  s:string;
  gl,gl2:tban;
begin
 with tbworldbot(botobject) do begin

  {if (parv[1] = '') or (parc < 2) then begin
    send(sendtalk+cmd+' <mask>');
    exit;
  end; }
  if pos('@',parv[1]) = 0 then parv[1] := '*@'+parv[1];

  s := ircupper(parv[1]);

  {exception exists?}
  gl2 := tban(exceptionlist);
  gl := nil;
  while gl2 <> nil do begin
    if (ircupper(gl2.mask) = s) then begin
      gl := gl2;
      break;
    end;
    gl2 := tban(gl2.next);
  end;
  if gl = nil then begin
    send(sendtalk+reply_exceptionnotfound+' '+parv[1]);
    exit;
  end;
  logaction(sptr,cmd+' '+gl.mask);
  linklistdel(tlinklist(exceptionlist),gl);
  gl.destroy;
 end;
end;

procedure priv_showclones(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  us : tuser;
begin
  with tbworldbot(botobject) do begin
    us := findnick(parv[1]);
    if assigned(us) and assigned(us.ipcheck) then begin
      send(sendtalk+inttostr(us.ipcheck.online));
    end else begin
      send(sendtalk+reply_nosuchuser);
    end;
  end;
end;
procedure priv_mode(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  a       : integer  ;
  us      : tuser    ;
  ch      : tchannel ;
  s       : string   ;
  counter : integer  ;
begin
 with botobject do begin

  {if (parv[2] = '') or (parc < 3) then begin
    send(sendtalk+cmd+' <channel> <params>');
    exit;
  end;}
  ch := findchan(parv[1]);
  if ch = nil then begin
    send(sendtalk+error_nosuchchannel(parv[1]));
    exit;
  end;
  {if not hasop(sptr,ch) then begin
    send(sendtalk+'no access');
    exit;
  end;}

  //{convert nicks to numerics}
  //for a := 2 to parc-1 do begin
  //  us := findname(parv[a]);
  //  if us <> nil then parv[a] := us.idstr;
  //end;

  a := 3;
  for counter := 1 to length(parv[2]) do begin
    if (parv[2][counter] <> '-')and(parv[2][counter] <> '+') then begin

      case modetype(parv[2][counter]) of
        mt_noparam : begin
        end;
        mt_param,mt_list : begin
          inc(a);

        end;
        mt_userchan : begin
          us := findname(parv[a]);
          if us <> nil then begin
            parv[a] := us.idstr;
          end else begin
            send(sendtalk+reply_nosuchnick);
            exit;
          end;
          inc(a);
        end;
        else begin
          send(sendtalk+reply_invalidmodechar+' '+parv[2][counter]);
          exit;
        end;

      end;

    end;
  end;
  if a > parc then begin
    send(sendtalk+reply_insufficiantmodeparams);
    exit;
  end;
  logaction(sptr,msg);
  s := botmodestring(mybot,ch);
  for a := 2 to parc-1 do s := s + ' '+parv[a];
  sendparse(s);

 end;
end;


end.
