(*
 *  beware IRC services, channelcommands.pas
 *  Copyright (C) 2002-2005 Bas Steendijk and Peter Green
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *)

unit channelcommands;

interface
uses
  channelbot       , infocmds          , buser             , bstuff        ,
  accountUSINGbot , accountmanagecmds , botmanagecommands , chanpowercmds ,
  chanflagstuff    , bconsts           ;

const
  botmaxcmd=40;



procedure priv_addchan(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_chanlev(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_chanflags(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_voice(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_welcome(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_limit(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_autolimit(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_key(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_chanlist(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_chaninfo(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_delchan(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);

var
// %nick% in the info or syntax field is replaced with the bots nick
// %server% in the info or syntax field is replaced with the services servers name
// %cmd% in the info or syntax field is replaced with the name of the command
// %newline% in the info or syntax field signifies a new line  note : USING this in
// the info field will really screw up the formatting of the help reply it is
// really intended for the syntax field

cmdtab:array[0..botmaxcmd] of tcmdtab=(
(
cmd:'HELP';
level:-1;
p:priv_showcommands;
minparams:1;
info:'Displays this list of commands, and get more help about a command';
syntax:'type /msg %nick% %cmd% [<command>]'),
(
cmd:'ADDCHAN';
level:960;
p:priv_addchan;
minparams:3;
info:'adds a channel to the bot';
syntax:'type /msg %nick% %cmd% <channel> <owner> '),
(
cmd:'CHANLEV';
level:1;
p:priv_chanlev;
minparams:2;
info:'Changes the access flags a user has on a channel';
syntax:'type /msg %nick% %cmd% <channel> [<username> <flags>]'),
(
cmd:'CHANLIST';
level:100;
p:priv_chanlist;
minparams:1;
info:'Lists registered channels.';
syntax:'type /msg %nick% %cmd% [<name mask>]'),
(
cmd:'USERLIST';
level:100;
p:priv_USERlist;
minparams:1;
info:'Lists user accounts.';
syntax:'type /msg %nick% %cmd% [<minlevel> [<maxlevel>]]'),
(
cmd:'CHANINFO';
level:100;
p:priv_chaninfo;
minparams:2;
info:'Displays information about a registered channel.';
syntax:'type /msg %nick% %cmd% <channel>'),
(
cmd:'USERINFO';
level:100;
p:priv_USERinfo;
minparams:2;
info:'Displays information about an account.';
syntax:'type /msg %nick% %cmd% <username>'),

(
cmd:'ADDUSER';
level:800;
p:priv_addUSER;
minparams:3;
info:'Creates a new user account.';
syntax:'type /msg %nick% %cmd% <username> <level>'),
(
cmd:'DELUSER';
level:800;
p:priv_delUSER;
minparams:2;
info:'Deletes an existing account.';
syntax:'type /msg %nick% %cmd% <username>'),
(
cmd:'MODUSER';
level:800;
p:priv_modUSER;
minparams:3;
info:'Modify''s a users account';
syntax:'type /msg %nick% %cmd% <username> <command> [<param>]%newline%commands: ADDMASK DELMASK NEWPASS LEVEL OPERONLY EMAIL'),
{(
cmd:'REHASH';
level:900;
p:priv_rehash;
minparams:1;
info:'Reloads the config and account data from HD.';
syntax:'type /msg %nick% %cmd%'),}
(
cmd:'SAVE';
level:900;
p:priv_save;
minparams:1;
info:'Saves the config and account data to HD.';
syntax:'type /msg %nick% %cmd%'),
(
cmd:'SAVEALL';
level:900 ;
p:priv_saveall;
minparams:1;
info:'save files of all bots';
syntax:'%cmd%'),

(

cmd:'RESTART';
level:900;
p:priv_restart;
minparams:1;
info:'Restarts %nick%.';
syntax:'type /msg %nick% %cmd%'),
(
cmd:'DIE';
level:900;
p:priv_die;
minparams:1;
info:'terminates bewareserv.';
syntax:'type /msg %nick% %cmd%'),
(
cmd:'DIEBOT';
level:900;
p:priv_diebot;
minparams:1;
info:'Stops only %nick%.';
syntax:'type /msg %nick% %cmd%'),
(
cmd:'CHLEVEL';
level:1000;
p:priv_level;
minparams:1;
info:'Changes the access level of a command.';
syntax:'%cmd% [<command>] [<level>]'),
(
cmd:'CHCOMNAME';
level:1000;
p:priv_chcomname;
minparams:3;
info:'Changes the name of a command.';
syntax:'%cmd% <old command name> <new command name>'),
(
cmd:'CHINFO';
level:1000;p:priv_chinfo;
minparams:3;
info:'Changes the info field for a command.';
syntax:'%cmd% <command> <new info setting>'),
(
cmd:'CHSYNTAX';
level:1000;
p:priv_chsyntax;
minparams:3;
info:'Changes the syntax field for a command.';
syntax:'%cmd% <command> <new syntax setting>'),
(
cmd:'SET';
level:1000;
p:priv_set;
minparams:2;
info:'view/change configuration of This bot';
syntax:'%cmd% <option> [<new value>|none]%newline%options:%options%';
extrareplaceproc:set_replace),
(
cmd:'GSET';
level:1000;
p:priv_globalset;
minparams:2;
info:'view/change configuration of the services server';
syntax:'%cmd% <option> [<new value>|none]%newline%options:%options%';
extrareplaceproc:globalset_replace),
(
cmd:'GSET';
level:1000;
p:priv_globalset;
minparams:2;
info:'view/change configuration of the services server';
syntax:'%cmd% <option> [<new value>|none]%newline%options:%options%';
extrareplaceproc:globalset_replace),
(
cmd:'RSET';
level:1000;
p:priv_replyset;
minparams:2;
info:'view/change reply strings';
syntax:'%cmd% <reply name> [<new value>|none]'),

(
cmd:'CHANFLAGS';
level:1;
p:priv_chanflags;
minparams:2;
info:'Changes flags applying to the whole channel.';
syntax:'%cmd% <channel> [<flags>]'),
(
cmd:'KICKALL';
level:0;
p:priv_kickall;
minparams:2;
info:'kick everyone in a channel';
syntax:'%cmd% <channel>'),
(
cmd:'OPALL';
level:0;
p:priv_opall;
minparams:2;
info:'op everyone in a channel';
syntax:'%cmd% <channel>'),
(
cmd:'DEOPALL';
level:0;
p:priv_deopall;
minparams:2;
info:'deop everyone in a channel';
syntax:'%cmd% <channel>'),
(
cmd:'CLEARMODES';
level:0;
p:priv_clearmode;
minparams:2;
info:'clear all modes on a modes';
syntax:'%cmd% <channel>'),
(
cmd:'CLEARBANS';
level:0;
p:priv_clearbans;
minparams:2;
info:'remove all bans on a channel';
syntax:'%cmd% <channel>'),
(
cmd:'OP';
level:0;
p:priv_op;
minparams:1;
info:'op someone in a channel';
syntax:'%cmd% [<channel>]'),
(
cmd:'DEOP';
level:0;
p:priv_deop;
minparams:1;
info:'deop someone on a channel';
syntax:'%cmd% [<channel>]'),
(
cmd:'VOICE';
level:0;
p:priv_voice;
minparams:2;
info:'give yourself voice in a channel';
syntax:'%cmd% <channel>'),
(
cmd:'WELCOME';
level:0;
p:priv_welcome;
minparams:2;
info:'show/set welcome message';
syntax:'%cmd% <channel> [<message>]'),
(
cmd:'LIMIT';
level:0;
p:priv_limit;
minparams:1;
info:'show/set limit for use with forcelimit setting 0 forces there to be no limit';
syntax:'%cmd% <channel> [<limit>|0]'),
(
cmd:'AUTOLIMIT';
level:0;
p:priv_autolimit;
minparams:1;
info:'show/set float for auto limit';
syntax:'%cmd% <channel> [<float>]'),
(
cmd:'KEY';
level:0;
p:priv_key;
minparams:1;
info:'show/set key for use with forcekey setting * forces there to be no key';
syntax:'%cmd% <channel> [<key>|*]'),

(
cmd:'INVITE';
level:0;
p:priv_invite;
minparams:1;
info:'invite yourself to a channel';
syntax:'%cmd% [<channel>]'),

(
cmd:'DELCHAN';
level:0;
p:priv_delchan;
minparams:2;
info:'delete a channel from the channel service';
syntax:'%cmd% <channel>'),
(
cmd:'SAY';
level:1000;
p:priv_say;
minparams:3;
info:'makes the service talk';
syntax:'%cmd% <channel|nick> <message>'),
(
cmd:'START';
level:1000;
p:priv_start;
minparams:2;
info:'starts a bot';
syntax:'%cmd% <botname>'),
(
cmd:'STOP';
level:1000;
p:priv_stop;
minparams:2;
info:'stops a bot';
syntax:'%cmd% <botname>')
);

implementation

uses
  sysutils , channeldb      , accountcore     , bparse , bchannel , btime ,
  bcmds    , generalreplies , channel_replies ;

procedure priv_addchan(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  rch : treggedchannel     ;
  ac  : taccount           ;
  arc : taccountreggedchan ;
  ch  : tchannel           ;
begin
  with botobject as tchannelbot do begin
    if assigned(findreggedchan(parv[1])) then begin
      send(sendtalk+reply_channelalreadyexists);
      exit;
    end;
    if (not validchanname(parv[1])) or (parv[1][1]<>'#') then begin
      send(sendtalk+reply_channelnameinvalid);
      exit;
    end;
    ac := taccountUSINGserviceunit(srvunit).accountcore.findaccount(parv[2]);
    if not assigned(ac) then begin
      send(sendtalk+reply_userdoesnotexist);
      exit;
    end;
    rch := createreggedchannel;
    setreggedchanname(rch,parv[1]);
    ch := findchan(parv[1]);
    if assigned(ch) then begin
      rch.ts:=ch.ts;
    end else begin
      rch.ts:=irctime;
    end;
    bot_join(mybot,parv[1],'+o',mybot.idstr,rch.ts);
    arc := addusertoreggedchannel(ac,rch);
    arc.flags := chanlev_auto+chanlev_master+chanlev_owner+chanlev_op;
  end;
end;


procedure priv_chanlev(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  rch                              : treggedchannel     ;
  arc                              : taccountreggedchan ;
  operationallowed                 : integer            ;
  sourceac                         : taccount           ;
  sourcearc                        : taccountreggedchan ;
  targetac                         : taccount           ;
  padlength                        : integer            ;
  padstr                           : string             ;
  flagstr                          : string             ;
  targetarc                        : taccountreggedchan ;
  targetismn                       : boolean            ;
  added            , removed , _new : integer ;
begin
  with tchannelbot(botobject) do begin
    rch := findreggedchan(parv[1]);
    if rch=nil then begin
      send(sendtalk+replacealias(reply_channelnotregistered,'%channel%',parv[1]));
      exit;
    end;
    if parc < 4 then begin
      arc := taccountreggedchan(rch.user);
      //send(sendtalk+'Users for channel '+parv[1]);
      //send(sendtalk+'username         Access flags');
      //send(sendtalk+'-----------------------------');
      send(sendtalk+replacealias(replacealias(reply_chanlevtitle,'%newline%',#10+sendtalk),'%channel%',parv[1]));
      while assigned(arc) do begin
        flagstr := makeflagstr(chanlevtable,maxchanlevtable,arc.flags);
        ;
        padlength := 29-length(arc.ac.name) -length(flagstr);
        if padlength > 0 then begin
          setlength(padstr,padlength);
          fillchar(padstr[1],padlength,' ');
        end else begin
          padstr := ' ';
        end;
        send(sendtalk+arc.ac.name+padstr+flagstr);
        arc := taccountreggedchan(arc.next2);
      end;
    end else begin

      targetac := taccountUSINGserviceunit(srvunit).accountcore.findaccount(parv[2]);
      targetarc := getaccountreggedchan(targetac,rch);
      if not assigned(targetac) then begin
        send(sendtalk+reply_targetdoesnotexist);
        exit;
      end;
      chanlevstrtobin(targetac,rch,targetarc,parv[3],added,removed,_new);
      if ((_new and chanlev_banned) <> 0) and (_new<>chanlev_banned) then begin
        send(sendtalk+reply_chanlevbismutallyexclusive);
      end;

      sourceac := taccountUSINGserviceunit(srvunit).accountcore.getaccountfromuser(sptr);
      if not assigned(sourceac) then begin
        if haslevel(sptr) > locopt.overridelevel then begin; // remember overridelevel could be lower than operlevel
          operationallowed := access_override;
        end else begin
          send(sendtalk+reply_youarenotloggedin);
          exit;
        end;
      end else begin
        if haslevel(sptr) > locopt.overridelevel then begin
          operationallowed := access_override;
        end else begin
          operationallowed := access_false;
        end;

        sourcearc := getaccountreggedchan(sourceac,rch);
        if ((rch.flags and chanflag_suspended) = 0) and assigned(sourcearc) then begin
          if (sourceac=targetac) and ((removed and chanlev_banned)=0) and (added=0) then begin
            //users can remove any flags from themselves except b
            operationallowed := access_true;
          end;

          if assigned(targetarc) then begin
            targetismn := (targetarc.flags and (chanlev_owner or chanlev_master)) <> 0;
          end else begin
            targetismn := false;
          end;

          if ((sourcearc.flags and chanlev_owner)<>0) then begin
            operationallowed := access_true;
          end;
          if ((sourcearc.flags and chanlev_master)<>0) then begin
            if ((added or removed) and (chanlev_owner or chanlev_master))=0 then begin //masters cant add or remove the owner or master flags
              if ((_new and (chanlev_owner or chanlev_master))=0) or (removed=0) then begin //masters can add to anyone but cant remove from other masters
                operationallowed := access_true;
              end;
            end;

          end;
        end;
      end;
      if operationallowed=access_override then begin
        logaction(sptr,cmd+' '+parv[1]+parv[2]);
      end;
      if operationallowed<> access_false then begin
        changechanlevbin(targetac,rch,targetarc,_new);
        send(sendtalk+reply_done);
      end else begin
        send(sendtalk+reply_noaccess);
      end;
    end;
  end;
end;

procedure priv_chanflags(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  rch              : treggedchannel     ;
  sourceac         : taccount           ;
  sourcearc        : taccountreggedchan ;
  operationallowed : boolean            ;
begin
  with tchannelbot(botobject) do begin
    rch := findreggedchan(parv[1]);
    if rch=nil then begin
      //send(sendtalk+'channel '+parv[1]+' not registered');
      send(sendtalk+replacealias(reply_channelnotregistered,'%channel%',parv[1]));
      exit;
    end;
    if parc < 3 then begin
      send(sendtalk+reply_currentflags+' '+makeflagstr(chanflagtable,maxchanflagtable, rch.flags));
    end else begin
      if haslevel(sptr) >= locopt.overridelevel then begin
        operationallowed := true;
      end else begin
        sourceac := taccountUSINGserviceunit(srvunit).accountcore.getaccountfromuser(sptr);
        if not assigned(sourceac) then begin
          send(sendtalk+reply_youarenotloggedin);
          exit;
        end;

        //operationallowed := false;
        sourcearc := getaccountreggedchan(sourceac,rch);
        operationallowed := (sourcearc.flags and (chanlev_owner or chanlev_master))<>0;
        {user can't change "suspended" flag}
        if pos('s',parv[2]) > 0 then operationallowed := false;
        if (rch.flags and chanflag_suspended) <> 0 then operationallowed := false;
      end;
      if operationallowed then begin
        changechanflags(rch,parv[2]);
        send(sendtalk+reply_done);
      end else begin
        send(sendtalk+reply_noaccess);
      end;
    end;
  end;
end;

procedure priv_voice(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  ch : tchannel;
  target : tuser;
begin
  with tchannelbot(botobject) do begin
    if parv[2] = '' then begin
      target := sptr;
    end else begin
      target := findname(parv[2]);
    end;
    if not assigned(target) then begin
      send(sendtalk+reply_nosuchuser);
      exit;
    end;
    ch := findchan(parv[1]);
    if not assigned(ch) then begin
      send(sendtalk+reply_nosuchchannel);
      exit;
    end;

    // chanflag +v can only vioce themselves chanflag +o can voice anyone on the
    // channel
    case hasop(sptr,ch) of
      access_false : begin

        if not ((hasvoice(sptr,ch)<>access_false)and(sptr=target)) then begin
          send(sendtalk+reply_noaccess);
          exit;
        end;
      end;
      access_override : begin
        logaction(sptr,cmd+' '+parv[1]+' '+parv[2]);
      end;
    end;
    sendparse(botmodestring(mybot,ch)+' +v '+target.idstr);
  end;
end;


procedure priv_welcome(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  counter    : integer ;
  spacecount : integer ;
  rch        : treggedchannel ;
begin
 with tchannelbot(botobject) do begin
  rch := findreggedchan(parv[1]);
  if not assigned(rch) then begin
    send(sendtalk+replacealias(reply_channelnotregistered,'%channel%',parv[1]));
    exit;
  end;

  if parc < 3 then begin
    send(sendtalk+rch.welcome);
    exit;
  end;

  if checkcommandaccess(sptr,parv[1],chanlev_owner or chanlev_master)=access_false then begin
    send(sendtalk+reply_noaccess);
    exit;
  end;
  counter := 2;
  spacecount := 0;
  while (counter < length(msg)) and (spacecount<2) do begin
    if (msg[counter]=' ') and (msg[counter-1]<>' ') then inc(spacecount);
    inc(counter);
  end;
  rch.welcome := copy(msg,counter,500);
  rch.flags := rch.flags or chanflag_welcomemessage;
 end;
end;

procedure priv_limit(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  counter    : integer ;
  spacecount : integer ;
  rch        : treggedchannel ;
begin
 with tchannelbot(botobject) do begin
  rch := findreggedchan(parv[1]);
  if not assigned(rch) then begin
    send(sendtalk+replacealias(reply_channelnotregistered,'%channel%',parv[1]));
    exit;
  end;
  if checkcommandaccess(sptr,parv[1],chanlev_owner or chanlev_master)=access_false then begin
    send(sendtalk+reply_noaccess);
    exit;
  end;

  if parc < 3 then begin
    send(sendtalk+inttostr(rch.limit));
    exit;
  end;
  try
    rch.limit := strtoint(parv[2]);
  except
    send(sendtalk+reply_notanumber);
  end;
 end;
end;

procedure priv_autolimit(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  counter    : integer ;
  spacecount : integer ;
  rch        : treggedchannel ;
begin
 with tchannelbot(botobject) do begin
  rch := findreggedchan(parv[1]);
  if not assigned(rch) then begin
    send(sendtalk+replacealias(reply_channelnotregistered,'%channel%',parv[1]));
    exit;
  end;
  if checkcommandaccess(sptr,parv[1],chanlev_owner or chanlev_master)=access_false then begin
    send(sendtalk+reply_noaccess);
    exit;
  end;

  if parc < 3 then begin
    send(sendtalk+inttostr(rch.autolimit));
    exit;
  end;
  try
    rch.autolimit := strtoint(parv[2]);
  except
    send(sendtalk+reply_notanumber);
  end;
 end;
end;

procedure priv_key(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  counter    : integer ;
  spacecount : integer ;
  rch        : treggedchannel ;
begin
 with tchannelbot(botobject) do begin
  rch := findreggedchan(parv[1]);
  if not assigned(rch) then begin
    send(sendtalk+replacealias(reply_channelnotregistered,'%channel%',parv[1]));
    exit;
  end;
  if checkcommandaccess(sptr,parv[1],chanlev_owner or chanlev_master)=access_false then begin
    send(sendtalk+reply_noaccess);
    exit;
  end;

  if parc < 3 then begin
    if rch.key <> '' then begin
      send(sendtalk+rch.key);
    end else begin
      send(sendtalk+'*');
    end;
    exit;
  end;
  if parv[2]='*' then parv[2]:='';
  rch.key := parv[2];
 end;
end;


procedure priv_chanlist(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  rch:treggedchannel;
  s,mask:string;
begin
 with tchannelbot(botobject) do begin
  if parc > 1 then mask := parv[1] else mask := '';
  if mask = '' then mask := '*';
  rch := treggedchannel(globalreggedchanlist);
  s := '';
  while assigned(rch) do begin
    if maskmatchup(mask,rch.name) then begin
      if s <> '' then s := s + '    ';
      s := s + rch.name;
      if length(s) > 80 then begin
        send(sendtalk+s);
        s := '';
      end;
    end;
    rch := treggedchannel(rch.next);
  end;
  if s <> '' then send(sendtalk+s);
  send(sendtalk+reply_endoflist);
 end;
end;

function maxlength4(const a,b,c,d:string) : integer;
begin
  result := length(a);
  if length(b) > result then result := length(b);
  if length(c) > result then result := length(c);
  if length(d) > result then result := length(d);

end;

function padleft(s:string;requiredlength:integer):string;
begin
  while length(s) < requiredlength do begin
    s := ' '+s;
  end;
  result := s
end;
procedure priv_chaninfo(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);



var
  rch:treggedchannel;
  s:string;
  a:integer;
begin
 with tchannelbot(botobject) do begin
  rch := findreggedchan(parv[1]);
  if not assigned(rch) then begin
    send(sendtalk+replacealias(reply_channelnotregistered,'%channel%',parv[1]));
    exit;
  end;

  //send(sendtalk+'            name: '+rch.name);
  //send(sendtalk+'           topic: '+rch.topic);
  //send(sendtalk+'    creationtime: '+agostr(irctime-rch.ts)+' ago');
  //if rch.lastseents = 0 then s := 'unknown' else s := agostr(irctime-rch.lastseents)+' ago';
  //send(sendtalk+' last seen owner: '+s);
  a := maxlength4(reply_chaninfo_name,reply_chaninfo_topic,reply_chaninfo_creationtime,reply_chaninfo_lastseenowner);
  inc(a);

  send(sendtalk+padleft(reply_chaninfo_name,a)+' '+rch.name);
  send(sendtalk+padleft(reply_chaninfo_topic,a)+' '+rch.topic);
  send(sendtalk+padleft(reply_chaninfo_creationtime,a)+' '+agostr(irctime-rch.ts)+' ago');
  if rch.lastseents = 0 then s := 'unknown' else s := agostr(irctime-rch.lastseents)+' ago';
  send(sendtalk+padleft(reply_chaninfo_lastseenowner,a)+' '+s);
  send(sendtalk+reply_endofinfo);
 end;
end;


procedure priv_delchan(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  rch              : treggedchannel     ;
  sourceac         : taccount           ;
  sourcearc        : taccountreggedchan ;
  operationallowed : boolean            ;
begin
  with tchannelbot(botobject) do begin
    rch := findreggedchan(parv[1]);
    if rch=nil then begin
      //send(sendtalk+'channel '+parv[1]+' not registered');
      send(sendtalk+replacealias(reply_channelnotregistered,'%channel%',parv[1]));
      exit;
    end;
    if haslevel(sptr) >= locopt.overridelevel then begin
        operationallowed := true;
    end else begin
      sourceac := taccountUSINGserviceunit(srvunit).accountcore.getaccountfromuser(sptr);
      if not assigned(sourceac) then begin
        send(sendtalk+reply_notloggedin);
        exit;
      end;
      //operationallowed := false;
      sourcearc := getaccountreggedchan(sourceac,rch);
      operationallowed := (sourcearc.flags and (chanlev_owner))<>0;

    end;
    if operationallowed then begin
      rch.destroy;
      changechanflags(rch,parv[2]);
    end else begin
      send(sendtalk+reply_noaccess);
    end;
  end;

end;


end.
