(*
 *  beware IRC services, logincmds.pas
 *  Copyright (C) 2002-2005 Bas Steendijk and Peter Green
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *)
unit logincmds;

interface
uses
  buser , bstuff , accountUSINGbot ;
{own account}
procedure priv_login(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);

procedure priv_deauth(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobj:taccountUSINGbot;const info,syntax:string);
procedure priv_newpass(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_drop(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);

implementation
uses
  accountcore , blinklist , bparse , bcmds , passcryp , binipstuff, unitbanmask, logincmds_replies,generalreplies;

procedure priv_login(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  a:integer;
  p:taccount;
  sl:tstringlinklist;
  s1,s2,s3:string;
  pp:tplinklist;

begin
 with botobject do begin
  {
  check:
  - is already logged in to anything
  - someone is already logged in to account
  - is ircop
  - mask
  - password.

  then associate user with account and account with user
  }


  {if (parv[2] = '') or (parc < 3) then begin
    send(sendtalk+cmd+' <username> <password>');
    exit;
  end;}
  if not localloginchecks(sptr,parc,parv,msg) then exit;
  if taccountUSINGserviceunit(srvunit).accountcore.getaccountfromuser(sptr) <> nil then begin
    if not ismortal(sptr) then send(sendtalk+reply_sorryalreadyauthenticated+' '+sptr.account);
    exit;
  end;

  p := taccountUSINGserviceunit(srvunit).accountcore.findaccount(parv[1]);
  if p = nil then begin
    //if not ismortal(sptr) then send(sendtalk+'AUTHENTICATION FAILED as '+parv[1]+'. Account does not exist.');
    if not ismortal(sptr) then send(sendtalk+replacealias(reply_authfailednosuchaccount,'%account%',parv[1]));
    exit;
  end;

  {if operonly: check}
  if not isoper(sptr) then if p.operonly then begin
    //logaction(sptr,'Failed login to '+p.name+': not IRCop');

    //if not ismortal(sptr) then send(sendtalk+'AUTHENTICATION FAILED as '+p.name+'. You''re not IRC Operator.');
    logaction(sptr,replacealias(log_authfailednotircop,'%account%',p.name));
    if not ismortal(sptr) then send(sendtalk+replacealias(reply_authfailednotircop,'%account%',p.name));

    exit;
  end;

  if (p.password = '') then begin
    //logaction(sptr,'Failed login to '+p.name+': account disabled.');
    //if not ismortal(sptr) then send(sendtalk+'AUTHENTICATION FAILED as '+p.name+'. Account disabled.');
    logaction(sptr,replacealias(log_authfailedaccountdisabled,'%account%',p.name));
    if not ismortal(sptr) then send(sendtalk+replacealias(reply_authfailedaccountdisabled,'%account%',p.name));

    exit;
  end;

  s1 := sptr.name+'!'+sptr.userid+'@'+sptr.host;
  s2 := sptr.name+'!'+sptr.userid+'@'+ircipbintostr(sptr.binip);
  sl := p.mask;
  a := 0;
  while sl <> nil do begin
    s3 := sl.s;
    if maskmatchup(s3,s1) or maskmatchup(s3,s2) then begin
      a := 1;
      break;
    end;
    sl := tstringlinklist(sl.next);
  end;
  if a = 0 then begin
    //logaction(sptr,'Failed login to '+p.name+': mask does not match');
    //if not ismortal(sptr) then send(sendtalk+'AUTHENTICATION FAILED as '+p.name+'. Your mask does not match.');

    logaction(sptr,replacealias(log_authfailedmaskmismatch,'%account%',p.name));
    if not ismortal(sptr) then send(sendtalk+replacealias(reply_authfailedmaskmismatch,'%account%',p.name));


    exit;
  end;

  if not taccountUSINGserviceunit(srvunit).accountcore.accountpasswordmatch(p,parv[2]) then begin
    //logaction(sptr,'Failed login to '+p.name+', Password incorrect.');
    //if not ismortal(sptr) then send(sendtalk+'AUTHENTICATION FAILED as '+p.name+'. Password incorrect.');

    logaction(sptr,replacealias(log_authfailedpassincorrect,'%account%',p.name));
    if not ismortal(sptr) then send(sendtalk+replacealias(reply_authfailedpassincorrect,'%account%',p.name));

    exit;
  end;


  pp := p.user;
  while pp <> nil do begin
    send(sendprefixstr(mybot)+TOK_NOTICE+' '+tuser(pp.p).idstr+' :'+nickuserhost(sptr)+' '+notify_loggedintoyouraccount);
    pp := tplinklist(pp.next);
  end;

  //sendparse(me.idstr+' '+TOK_ACCOUNT+' '+sptr.idstr+' '+ parv[1]);
  taccountUSINGserviceunit(srvunit).accountcore.login(sptr,parv[1]);
  send(sendtalk+replacealias(reply_authsuccessfull,'%account%',p.name));

  p.requestedpass := '';
  p.password := passnewcrypt(parv[2]);

  if p.level = 0 then p.level := 1;
(*  logaction(sptr,'LOGIN');*)
 end;
end;
procedure priv_deauth(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobj:taccountUSINGbot;const info,syntax:string);
begin
 with botobj do begin
  if taccountUSINGserviceunit(srvunit).accountcore.mode=0 then begin
    send(sendtalk+reply_amsnodeauth);

  end else begin
    if taccountUSINGserviceunit(srvunit).accountcore.getaccountfromuser(sptr) = nil then begin
      send(sendtalk+reply_notloggedin);
      exit;
    end;

    taccountUSINGserviceunit(srvunit).accountcore.deauth(sptr);
    send(sendtalk+reply_deauthsucess);
  end;
 end;
end;

procedure priv_newpass(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  p:taccount;

begin
 with botobject do begin
  {if (parv[3] = '') or (parc < 4) then begin
    send(sendtalk+cmd+' <old> <new> <new>');
    exit;
  end;}

  p := taccountUSINGserviceunit(srvunit).accountcore.getaccountfromuser(sptr);
  if p = nil then begin
    send(sendtalk+reply_notloggedin);
    exit;
  end;

  if (not taccountUSINGserviceunit(srvunit).accountcore.accountpasswordmatch(p,parv[1])) then begin
    send(sendtalk+reply_passincorrect);
    exit;
  end;

  if (parv[2] <> parv[3]) then begin
    send(sendtalk+reply_newpassmismatch);
    exit;
  end;

  if ircupper(parv[4])='PRECRYPT' then begin
    p.password := parv[3];
  end else begin
    p.password := passnewcrypt(parv[3]);
  end;


  logaction(sptr,'NEWPASS');
  send(sendtalk+reply_newpasssuccess);
                
 end;
end;

procedure priv_drop(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  p:taccount;
begin
 with botobject do begin
  {if (parc < 3) or (parv[2] = '') then begin
    send(sendtalk+' To remove your account, type /msg A '+cmd+' <myusername> <mypassword>');
    exit
  end;}
  p := taccountUSINGserviceunit(srvunit).accountcore.findaccount(parv[1]);
  if p <> taccountUSINGserviceunit(srvunit).accountcore.getaccountfromuser(sptr) then begin
    send(sendtalk+reply_onlydropown);
    exit;
  end;

  if taccountUSINGserviceunit(srvunit).accountcore.getaccountfromuser(sptr) = nil then begin
    {this code will only run if the admin is a lamer and makes drop availablie to level -1 users or if the source user is an ircop getting level through operlevel}
    send(sendtalk+reply_notloggedin);
    exit;
  end;

  if not taccountUSINGserviceunit(srvunit).accountcore.accountpasswordmatch(p,parv[2]) then begin
    send(sendtalk+reply_passincorrect);
    exit;
  end;

  send(sendtalk+reply_dropsucess);

  logaction(sptr,cmd+' '+p.name);
  linklistdel(tlinklist(taccountUSINGserviceunit(srvunit).accountcore.accountlist),tlinklist(p));
  p.destroy;

  {}
 end;
end;

end.
